// OSˑ̔ėp[`(UIp)

#include <windows.h>
#include <mmsystem.h>
#include <shlobj.h>
#include <string.h>

#include <SDL.h>
#include <SDL_syswm.h>
#include <SDL_endian.h>

#include "../log.h"
#include "../osd.h"
#include "../common.h"
#include "../vsurface.h"

#if SDL_VERSION_ATLEAST(2,0,0)
#include "icons2.h"
#else
#include "icons.h"
#endif



///////////////////////////////////////////////////////////
// SDL֘A
///////////////////////////////////////////////////////////
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
#define	AUDIOFORMAT	AUDIO_S16MSB	// 16rbg
#else
#define	AUDIOFORMAT	AUDIO_S16		// 16rbg
#endif

// SDLT[tFXpIvV
#define SDLOP_SCREEN	(SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWACCEL)

// [U[`Cxg
#define UEV_FPSUPDATE	(SDL_USEREVENT+0)
#define UEV_RESTART		(SDL_USEREVENT+1)
#define UEV_DOKOLOAD	(SDL_USEREVENT+2)
#define UEV_REPLAY		(SDL_USEREVENT+3)
#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define UEV_DEBUGMODEBP	(SDL_USEREVENT+4)
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#define USESDLTIMER					// SDL̃^C}gp




#ifndef USESDLTIMER
#define TIMERRES	10				// ^C}𑜓x
// ^C}
struct TINFO {
	UINT id;			// ^C}ID
	DWORD interval;		// ݊Ԋu(ms)
	CBF_TMR callback;	// R[obN֐
	void *param;		// R[obN֐ɓn
	TINFO *next;		// ̃^C}ւ̃|C^
	
	TINFO() : id(0), callback(NULL), param(NULL), next(NULL) {}
};
#endif


///////////////////////////////////////////////////////////
// [J֐`
///////////////////////////////////////////////////////////
// OSD_FolderDiaog()ŎgpR[obNvV[W
static int CALLBACK OsdBrowseCallbackProc( HWND, UINT, LPARAM, LPARAM );
#ifndef USESDLTIMER
// OSD_AddTimer()ŎgpR[obNvV[W
static void CALLBACK OsdTimerCallbackProc( UINT, UINT, DWORD_PTR, DWORD_PTR, DWORD_PTR );
#endif

///////////////////////////////////////////////////////////
// X^eBbNϐ
///////////////////////////////////////////////////////////
static HANDLE hMutex;						// dN`FbNp̃~[ebNX
static BROWSEINFO OBI;						// OSD_FolderDiaog()Ŏgpi[\

#if SDL_VERSION_ATLEAST(2,0,0)
static PCKEYsym VKTable[SDL_NUM_SCANCODES];	// SDLXLR[h  -> zL[R[h ϊe[u
#else
static PCKEYsym VKTable[SDLK_LAST];			// SDLL[R[h  -> zL[R[h ϊe[u
#endif



#ifndef USESDLTIMER
static TINFO *tif;
#endif
///////////////////////////////////////////////////////////
// 萔
///////////////////////////////////////////////////////////
#if SDL_VERSION_ATLEAST(2,0,0)
static const struct {	// SDLXLR[h -> zL[R[h`
	SDL_Scancode InKey;	// SDL̃XLR[h
	PCKEYsym VKey;		// zL[R[h
} VKeyDef[] = {
	{ SDL_SCANCODE_UNKNOWN,			KVC_UNKNOWN },
	
	{ SDL_SCANCODE_1,				KVC_1 },			// 1	!
	{ SDL_SCANCODE_2,				KVC_2 },			// 2	"
	{ SDL_SCANCODE_3,				KVC_3 },			// 3	#
	{ SDL_SCANCODE_4,				KVC_4 },			// 4	$
	{ SDL_SCANCODE_5,				KVC_5 },			// 5	%
	{ SDL_SCANCODE_6,				KVC_6 },			// 6	&
	{ SDL_SCANCODE_7,				KVC_7 },			// 7	'
	{ SDL_SCANCODE_8,				KVC_8 },			// 8	(
	{ SDL_SCANCODE_9,				KVC_9 },			// 9	)
	{ SDL_SCANCODE_0,				KVC_0 },			// 0
	
	{ SDL_SCANCODE_A,				KVC_A },			// a	A
	{ SDL_SCANCODE_B,				KVC_B },			// b	B
	{ SDL_SCANCODE_C,				KVC_C },			// c	C
	{ SDL_SCANCODE_D,				KVC_D },			// d	D
	{ SDL_SCANCODE_E,				KVC_E },			// e	E
	{ SDL_SCANCODE_F,				KVC_F },			// f	F
	{ SDL_SCANCODE_G,				KVC_G },			// g	G
	{ SDL_SCANCODE_H,				KVC_H },			// h	H
	{ SDL_SCANCODE_I,				KVC_I },			// i	I
	{ SDL_SCANCODE_J,				KVC_J },			// j	J
	{ SDL_SCANCODE_K,				KVC_K },			// k	K
	{ SDL_SCANCODE_L,				KVC_L },			// l	L
	{ SDL_SCANCODE_M,				KVC_M },			// m	M
	{ SDL_SCANCODE_N,				KVC_N },			// n	N
	{ SDL_SCANCODE_O,				KVC_O },			// o	O
	{ SDL_SCANCODE_P,				KVC_P },			// p	P
	{ SDL_SCANCODE_Q,				KVC_Q },			// q	Q
	{ SDL_SCANCODE_R,				KVC_R },			// r	R
	{ SDL_SCANCODE_S,				KVC_S },			// s	S
	{ SDL_SCANCODE_T,				KVC_T },			// t	T
	{ SDL_SCANCODE_U,				KVC_U },			// u	U
	{ SDL_SCANCODE_V,				KVC_V },			// v	V
	{ SDL_SCANCODE_W,				KVC_W },			// w	W
	{ SDL_SCANCODE_X,				KVC_X },			// x	X
	{ SDL_SCANCODE_Y,				KVC_Y },			// y	Y
	{ SDL_SCANCODE_Z,				KVC_Z },			// z	Z
	
	{ SDL_SCANCODE_F1,				KVC_F1 },			// F1
	{ SDL_SCANCODE_F2,				KVC_F2 },			// F2
	{ SDL_SCANCODE_F3,				KVC_F3 },			// F3
	{ SDL_SCANCODE_F4,				KVC_F4 },			// F4
	{ SDL_SCANCODE_F5,				KVC_F5 },			// F5
	{ SDL_SCANCODE_F6,				KVC_F6 },			// F6
	{ SDL_SCANCODE_F7,				KVC_F7 },			// F7
	{ SDL_SCANCODE_F8,				KVC_F8 },			// F8
	{ SDL_SCANCODE_F9,				KVC_F9 },			// F9
	{ SDL_SCANCODE_F10,				KVC_F10 },			// F10
	{ SDL_SCANCODE_F11,				KVC_F11 },			// F11
	{ SDL_SCANCODE_F12,				KVC_F12 },			// F12
	
	{ SDL_SCANCODE_MINUS,			KVC_MINUS },		// -	=
	{ SDL_SCANCODE_APOSTROPHE,		KVC_CARET },		// ^	~
	{ SDL_SCANCODE_BACKSPACE,		KVC_BACKSPACE },	// BackSpace
	{ SDL_SCANCODE_GRAVE,			KVC_AT },			// @	`
	{ SDL_SCANCODE_LEFTBRACKET,		KVC_LBRACKET },		// [	{
	{ SDL_SCANCODE_EQUALS,			KVC_SEMICOLON },	// ;	+
	{ SDL_SCANCODE_SEMICOLON,		KVC_COLON },		// :	*
	{ SDL_SCANCODE_COMMA,			KVC_COMMA },		// ,	<
	{ SDL_SCANCODE_PERIOD,			KVC_PERIOD },		// .	>
	{ SDL_SCANCODE_SLASH,			KVC_SLASH },		// /	?
	{ SDL_SCANCODE_SPACE,			KVC_SPACE },		// Space
	
	{ SDL_SCANCODE_ESCAPE,			KVC_ESC },			// ESC
	{ SDL_SCANCODE_TAB,				KVC_TAB },			// Tab
	{ SDL_SCANCODE_CAPSLOCK,		KVC_CAPSLOCK },		// CapsLock
	{ SDL_SCANCODE_RETURN,			KVC_ENTER },		// Enter
	{ SDL_SCANCODE_LCTRL,			KVC_LCTRL },		// L-Ctrl
	{ SDL_SCANCODE_RCTRL,			KVC_RCTRL },		// R-Ctrl
	{ SDL_SCANCODE_LSHIFT,			KVC_LSHIFT },		// L-Shift
	{ SDL_SCANCODE_RSHIFT,			KVC_RSHIFT },		// R-Shift
	{ SDL_SCANCODE_LALT,			KVC_LALT },			// L-Alt
	{ SDL_SCANCODE_RALT,			KVC_RALT },			// R-Alt
	{ SDL_SCANCODE_PRINTSCREEN,		KVC_PRINT },		// PrintScreen
	{ SDL_SCANCODE_PRINTSCREEN,		KVC_SCROLLLOCK },	// ScrollLock
	{ SDL_SCANCODE_PAUSE,			KVC_PAUSE },		// Pause
	{ SDL_SCANCODE_INSERT,			KVC_INSERT },		// Insert
	{ SDL_SCANCODE_DELETE,			KVC_DELETE },		// Delete
	{ SDL_SCANCODE_END,				KVC_END },			// End
	{ SDL_SCANCODE_HOME,			KVC_HOME },			// Home
	{ SDL_SCANCODE_PAGEUP,			KVC_PAGEUP },		// PageUp
	{ SDL_SCANCODE_PAGEDOWN,		KVC_PAGEDOWN },		// PageDown
	
	{ SDL_SCANCODE_UP,				KVC_UP },			// 
	{ SDL_SCANCODE_DOWN,			KVC_DOWN },			// 
	{ SDL_SCANCODE_LEFT,			KVC_LEFT },			// 
	{ SDL_SCANCODE_RIGHT,			KVC_RIGHT },		// 
	
	{ SDL_SCANCODE_KP_0,			KVC_P0 },			// [0]
	{ SDL_SCANCODE_KP_1,			KVC_P1 },			// [1]
	{ SDL_SCANCODE_KP_2,			KVC_P2 },			// [2]
	{ SDL_SCANCODE_KP_3,			KVC_P3 },			// [3]
	{ SDL_SCANCODE_KP_4,			KVC_P4 },			// [4]
	{ SDL_SCANCODE_KP_5,			KVC_P5 },			// [5]
	{ SDL_SCANCODE_KP_6,			KVC_P6 },			// [6]
	{ SDL_SCANCODE_KP_7,			KVC_P7 },			// [7]
	{ SDL_SCANCODE_KP_8,			KVC_P8 },			// [8]
	{ SDL_SCANCODE_KP_9,			KVC_P9 },			// [9]
	{ SDL_SCANCODE_NUMLOCKCLEAR,	KVC_NUMLOCK },		// NumLock
	{ SDL_SCANCODE_KP_PLUS,			KVC_P_PLUS },		// [+]
	{ SDL_SCANCODE_KP_MINUS,		KVC_P_MINUS },		// [-]
	{ SDL_SCANCODE_KP_MULTIPLY,		KVC_P_MULTIPLY },	// [*]
	{ SDL_SCANCODE_KP_DIVIDE,		KVC_P_DIVIDE },		// [/]
	{ SDL_SCANCODE_KP_PERIOD,		KVC_P_PERIOD },		// [.]
	{ SDL_SCANCODE_KP_ENTER,		KVC_P_ENTER },		// [Enter]
	
	// {L[{[ĥ
	{ SDL_SCANCODE_BACKSLASH,		KVC_YEN },			// 	|
	{ SDL_SCANCODE_RIGHTBRACKET,	KVC_RBRACKET },		// ]	}
	{ SDL_SCANCODE_NONUSBACKSLASH,	KVC_UNDERSCORE },	// 	_
//	{ 				,				KVC_HANZEN },		// p/Sp
//	{ 				,				KVC_MUHENKAN },		// ϊ
//	{ 				,				KVC_HENKAN },		// ϊ
//	{ 				,				KVC_HIRAGANA },		// Ђ炪
	
	// ǉL[
	{ SDL_SCANCODE_LGUI,			KVX_LMETA },		// L-Meta
	{ SDL_SCANCODE_RGUI,			KVX_RMETA },		// R-Meta
	{ SDL_SCANCODE_MENU,			KVX_MENU }			// Menu
};
#else
static const struct {	// SDLL[R[h -> zL[R[h`
	int InKey;			// SDL̃L[R[h
	PCKEYsym VKey;		// zL[R[h
} VKeyDef[] = {
	{ SDLK_UNKNOWN,			KVC_UNKNOWN },
	
	{ SDLK_1,				KVC_1 },			// 1	!
	{ SDLK_2,				KVC_2 },			// 2	"
	{ SDLK_3,				KVC_3 },			// 3	#
	{ SDLK_4,				KVC_4 },			// 4	$
	{ SDLK_5,				KVC_5 },			// 5	%
	{ SDLK_6,				KVC_6 },			// 6	&
	{ SDLK_7,				KVC_7 },			// 7	'
	{ SDLK_8,				KVC_8 },			// 8	(
	{ SDLK_9,				KVC_9 },			// 9	)
	{ SDLK_0,				KVC_0 },			// 0
	
	{ SDLK_a,				KVC_A },			// a	A
	{ SDLK_b,				KVC_B },			// b	B
	{ SDLK_c,				KVC_C },			// c	C
	{ SDLK_d,				KVC_D },			// d	D
	{ SDLK_e,				KVC_E },			// e	E
	{ SDLK_f,				KVC_F },			// f	F
	{ SDLK_g,				KVC_G },			// g	G
	{ SDLK_h,				KVC_H },			// h	H
	{ SDLK_i,				KVC_I },			// i	I
	{ SDLK_j,				KVC_J },			// j	J
	{ SDLK_k,				KVC_K },			// k	K
	{ SDLK_l,				KVC_L },			// l	L
	{ SDLK_m,				KVC_M },			// m	M
	{ SDLK_n,				KVC_N },			// n	N
	{ SDLK_o,				KVC_O },			// o	O
	{ SDLK_p,				KVC_P },			// p	P
	{ SDLK_q,				KVC_Q },			// q	Q
	{ SDLK_r,				KVC_R },			// r	R
	{ SDLK_s,				KVC_S },			// s	S
	{ SDLK_t,				KVC_T },			// t	T
	{ SDLK_u,				KVC_U },			// u	U
	{ SDLK_v,				KVC_V },			// v	V
	{ SDLK_w,				KVC_W },			// w	W
	{ SDLK_x,				KVC_X },			// x	X
	{ SDLK_y,				KVC_Y },			// y	Y
	{ SDLK_z,				KVC_Z },			// z	Z
	
	{ SDLK_F1,				KVC_F1 },			// F1
	{ SDLK_F2,				KVC_F2 },			// F2
	{ SDLK_F3,				KVC_F3 },			// F3
	{ SDLK_F4,				KVC_F4 },			// F4
	{ SDLK_F5,				KVC_F5 },			// F5
	{ SDLK_F6,				KVC_F6 },			// F6
	{ SDLK_F7,				KVC_F7 },			// F7
	{ SDLK_F8,				KVC_F8 },			// F8
	{ SDLK_F9,				KVC_F9 },			// F9
	{ SDLK_F10,				KVC_F10 },			// F10
	{ SDLK_F11,				KVC_F11 },			// F11
	{ SDLK_F12,				KVC_F12 },			// F12
	
	{ SDLK_MINUS,			KVC_MINUS },		// -	=
	{ SDLK_CARET,			KVC_CARET },		// ^	~
	{ SDLK_BACKSPACE,		KVC_BACKSPACE },	// BackSpace
	{ SDLK_AT,				KVC_AT },			// @	`
	{ SDLK_LEFTBRACKET,		KVC_LBRACKET },		// [	{
	{ SDLK_SEMICOLON,		KVC_SEMICOLON },	// ;	+
	{ SDLK_COLON,			KVC_COLON },		// :	*
	{ SDLK_COMMA,			KVC_COMMA },		// ,	<
	{ SDLK_PERIOD,			KVC_PERIOD },		// .	>
	{ SDLK_SLASH,			KVC_SLASH },		// /	?
	{ SDLK_SPACE,			KVC_SPACE },		// Space
	
	{ SDLK_ESCAPE,			KVC_ESC },			// ESC
	{ SDLK_BACKQUOTE,		KVC_HANZEN },		// p/Sp
	{ SDLK_TAB,				KVC_TAB },			// Tab
	{ SDLK_CAPSLOCK,		KVC_CAPSLOCK },		// CapsLock
	{ SDLK_RETURN,			KVC_ENTER },		// Enter
	{ SDLK_LCTRL,			KVC_LCTRL },		// L-Ctrl
	{ SDLK_RCTRL,			KVC_RCTRL },		// R-Ctrl
	{ SDLK_LSHIFT,			KVC_LSHIFT },		// L-Shift
	{ SDLK_RSHIFT,			KVC_RSHIFT },		// R-Shift
	{ SDLK_LALT,			KVC_LALT },			// L-Alt
	{ SDLK_RALT,			KVC_RALT },			// R-Alt
	{ SDLK_PRINT,			KVC_PRINT },		// PrintScreen
	{ SDLK_SCROLLOCK,		KVC_SCROLLLOCK },	// ScrollLock
	{ SDLK_PAUSE,			KVC_PAUSE },		// Pause
	{ SDLK_INSERT,			KVC_INSERT },		// Insert
	{ SDLK_DELETE,			KVC_DELETE },		// Delete
	{ SDLK_END,				KVC_END },			// End
	{ SDLK_HOME,			KVC_HOME },			// Home
	{ SDLK_PAGEUP,			KVC_PAGEUP },		// PageUp
	{ SDLK_PAGEDOWN,		KVC_PAGEDOWN },		// PageDown
	
	{ SDLK_UP,				KVC_UP },			// 
	{ SDLK_DOWN,			KVC_DOWN },			// 
	{ SDLK_LEFT,			KVC_LEFT },			// 
	{ SDLK_RIGHT,			KVC_RIGHT },		// 
	
	{ SDLK_KP0,				KVC_P0 },			// [0]
	{ SDLK_KP1,				KVC_P1 },			// [1]
	{ SDLK_KP2,				KVC_P2 },			// [2]
	{ SDLK_KP3,				KVC_P3 },			// [3]
	{ SDLK_KP4,				KVC_P4 },			// [4]
	{ SDLK_KP5,				KVC_P5 },			// [5]
	{ SDLK_KP6,				KVC_P6 },			// [6]
	{ SDLK_KP7,				KVC_P7 },			// [7]
	{ SDLK_KP8,				KVC_P8 },			// [8]
	{ SDLK_KP9,				KVC_P9 },			// [9]
	{ SDLK_NUMLOCK,			KVC_NUMLOCK },		// NumLock
	{ SDLK_KP_PLUS,			KVC_P_PLUS },		// [+]
	{ SDLK_KP_MINUS,		KVC_P_MINUS },		// [-]
	{ SDLK_KP_MULTIPLY,		KVC_P_MULTIPLY },	// [*]
	{ SDLK_KP_DIVIDE,		KVC_P_DIVIDE },		// [/]
	{ SDLK_KP_PERIOD,		KVC_P_PERIOD },		// [.]
	{ SDLK_KP_ENTER,		KVC_P_ENTER },		// [Enter]
	
	// {L[{[ĥ
	{ SDLK_BACKSLASH,		KVC_YEN },			// 	|
	{ SDLK_RIGHTBRACKET,	KVC_RBRACKET },		// ]	}
	{ SDLK_LESS,			KVC_UNDERSCORE },	// 	_
//	{ 				,		KVC_MUHENKAN },		// ϊ
//	{ 				,		KVC_HENKAN },		// ϊ
//	{ 				,		KVC_HIRAGANA },		// Ђ炪
	
	// ǉL[
	{ SDLK_LMETA,			KVX_LMETA },		// L-Meta
	{ SDLK_RMETA,			KVX_RMETA },		// R-Meta
	{ SDLK_MENU,			KVX_MENU }			// Menu
};
#endif


///////////////////////////////////////////////////////////
// bZ[Wz
///////////////////////////////////////////////////////////
// ʃbZ[W
const char *MsgStr[] = {
	"IĂ낵ł?",
	"ImF",
	"ċNĂ낵ł?",
	"ύX͍ċNɗLƂȂ܂B\nċN܂?",
	"ċNmF",
	"gROM}ăZbg܂B",
	"gROMroăZbg܂B",
	"ZbgmF"
};

// j[pbZ[W ------
const char *MsgMen[] = {
	"rfILv`...",
	"rfILv`~",
	"L^...",	// (vC)
	"L^~",	// (vC)
	"Đ...",	// (vC)
	"Đ~"	// (vC)
};

// INIt@CpbZ[W ------
const char *MsgIni[] = {
	// [CONFIG]
	"; === PC6001V ݒt@C ===\n\n",
//	"@ 60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR",
	"@ 60:PC-6001 62:PC-6001mk2 66:PC-6601",
	"FDDڑ䐔 (0-2)",
	"gRAMgp",
	"Turbo TAPE Yes:L No:",
	"BoostUp Yes:L No:",
	"BoostUp ő{(N60[h)",
	"BoostUp ő{(N60m/N66[h)",
	"I[o[NbN (1-1000)%",
	"CRC`FbN Yes:L No:",
	"ROMpb` Yes:Ă No:ĂȂ",
	// [DISPLAY]
	"J[[h 8:8bit 16:16bit 24:24bit",
	"MODE4J[[h 0:mN 1:/ 2:/ 3:sN/ 4:/sN",
	"XLC Yes: No:Ȃ",
	"XLCPx (0-100)%",
	"4:3\ Yes:L No:",
	"tXN[[h Yes:L No:",
	"Xe[^Xo[ Yes:\ No:\",
	"t[XLbv",
	// [SOUND]
	"TvO[g (44100/22050/11025)Hz",
	"TEhobt@TCY",
	"}X^[ (0-100)",
	"PSG (0-100)",
	" (0-100)",
	"TAPEj^ (0-100)",
	"PSG LPFJbgItg(0Ŗ)",
	// [MOVIE]
	"RLEtO Yes:RLEL No:x^",
	// [FILES]
	"gROMt@C",
	"TAPE(LODE)t@C(NɎ}Eg)",
	"TAPE(SAVE)t@C(SAVEɎ}Eg)",
	"DISK1t@C(NɎ}Eg)",
	"DISK2t@C(NɎ}Eg)",
	"v^o̓t@C",
	"SptHgt@C",
	"ptHgt@C",
	// [PATH]
	"ROMC[Wi[pX",
	"TAPEC[Wi[pX",
	"DISKC[Wi[pX",
	"gROMC[Wi[pX",
	"XibvVbgi[pX",
	"WAVEt@Ci[pX",
	"FONTi[pX",
	// [CHECK]
	"ImF Yes: No:Ȃ",
	"IINIt@Cۑ Yes: No:Ȃ",
	// [KEY]
	"L[s[g̊Ԋu(P:ms 0Ŗ)",
	"PS/2L[{[hg? Yes:PS/2 No:USB",
	// [OPTION]
	"m̃J[gbW Yes:L No:"
	
};

// ǂłSAVEpbZ[W ------
const char *MsgDok[] = {
	"; === PC6001V ǂłSAVEt@C ===\n\n"
};

// ErrorpbZ[W ------
const char *MsgErr[] = {
	"Error",
	"G[͂܂",
	"s̃G[܂",
	"̊mۂɎs܂",
	"w肳ꂽ@ROMC[WȂߋ@ύX܂\nݒmFĂ",
	"ROMC[W܂\nݒƃt@CmFĂ",
	"ROMC[W̃TCYsł",
	"ROMC[WCRCsł",
	"CȕɎs܂",
	"Ɏs܂\nݒmFĂ",
	"tHg̓Ǎ݂Ɏs܂",
	"tHgt@C̍쐬Ɏs܂",
	"INIt@C̓Ǎ݂Ɏs܂\nftHgݒŋN܂",
	"INIt@C̓Ǎ݂Ɏs܂",
	"INIt@C̕ۑɎs܂",
	"TAPEC[W̃}EgɎs܂",
	"DISKC[W̃}EgɎs܂",
	"gROMC[W̃}EgɎs܂",
	"ǂłLOADɎs܂",
	"ǂłSAVEɎs܂",
	"ǂłLOADɎs܂\nۑPC6001Ṽo[WقȂ܂",
	"vCĐɎs܂",
	"vCL^Ɏs܂",
	"vCf[^܂"
};


////////////////////////////////////////////////////////////////
// ɂ镶r
//
// :	s1			r镶ւ̃|C^1
//			s2			r镶ւ̃|C^2
// Ԓl:	int			0: :s1>s2 :s1<s2
////////////////////////////////////////////////////////////////
int stricmp ( const char *s1, const char *s2 )
{
	const char *ps1 = s1, *ps2 = s2;
	
	if( !s1 ) return -1;
	if( !s2 ) return  1;
	
	// 擪̕
	char c1 = *ps1++;
	char c2 = *ps2++;
	
	// ǂ炩̕I[܂ŌJԂ
	while( c1 && c2 ){
		// ɕϊ
		if( c1 >= 'A' && c1 <= 'Z' ) c1 += 'a' - 'A';
		if( c2 >= 'A' && c2 <= 'Z' ) c2 += 'a' - 'A';
		
		// ȂrI
		if( c1 != c2 ) break;
		
		// ̕擾
		c1 = *ps1++;
		c2 = *ps2++;
	}
	
	return (int)c1 - (int)c2;
}


////////////////////////////////////////////////////////////////
// pX̃f~^'/'ɕϊ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void Delimiter( char *path )
{
	wchar_t wstr[PATH_MAX];
	mbstowcs( wstr, path, PATH_MAX );
	
	while( wchar_t *c = wcschr( wstr, L'\\') )
		*c = L'/';
	
	wcstombs( path, wstr, PATH_MAX );

//	while( char *c = strchr( path, '\\') )
//		*c = '/';
}


////////////////////////////////////////////////////////////////
// pX̃f~^'\'ɕϊ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void UnDelimiter( char *path )
{
	wchar_t wstr[PATH_MAX];
	mbstowcs( wstr, path, PATH_MAX );
	
	while( wchar_t *c = wcschr( wstr, L'/') )
		*c = L'\\';
	
	wcstombs( path, wstr, PATH_MAX );

//	while( char *c = strchr( path, '/') )
//		*c = '\\';
}


////////////////////////////////////////////////////////////////
// pX̖Ƀf~^ǉ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void AddDelimiter( char *path )
{
	if( !strlen( path ) )
		strncpy( path, "/", PATH_MAX );
	else if( (path[strlen(path)-1] != '/' ) && ( path[strlen(path)-1] != '\\') )
		strncat( path, "/", PATH_MAX );
}


////////////////////////////////////////////////////////////////
// pX̖̃f~^폜
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DelDelimiter( char *path )
{
	if( strlen( path ) > 1 )
		while( ( path[strlen(path)-1] == '/' ) || ( path[strlen(path)-1] == '\\' ) )
			path[strlen(path)-1] = '\0';
}


////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_Init( void )
{
	if( SDL_Init( SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_JOYSTICK ) )
		return false;
	
	// SDLL[R[h  -> zL[R[h ϊe[u
	ZeroMemory( &VKTable, sizeof(VKTable) );
	for( int i=0; i < COUNTOF(VKeyDef); i++ ) VKTable[VKeyDef[i].InKey] = VKeyDef[i].VKey;
	
	#if SDL_VERSION_ATLEAST(2,0,0)
	// SDL2.0̓L[V{UnicodeɑΉĂ炵
	#else
	// UnicodeL I[o[wbh͋CɂȂƂɂ
	SDL_EnableUNICODE( 1 );
	#endif
	
	#ifndef USESDLTIMER
	tif = NULL;
	#endif
	
	return true;
}


////////////////////////////////////////////////////////////////
// I
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_Quit( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_Quit]\n" );
	
	#ifndef USESDLTIMER
	// ^C}S폜
	TINFO *ti    = tif;
	TINFO *tip   = NULL;
	while( ti ){
		timeKillEvent( ti->id );
		timeEndPeriod( TIMERRES );
		tip = ti;
		ti = ti->next;
		delete tip;
	}
	tif = NULL;
	#endif
	
	
	// Mutex J
	ReleaseMutex( hMutex );
	
	SDL_Quit();
}


////////////////////////////////////////////////////////////////
// dN`FbN
//
// :	Ȃ
// Ԓl:	bool		true:Nς false:N
////////////////////////////////////////////////////////////////
bool OSD_IsWorking( void )
{
	// CEBhENX̖O
	#define	MWCLASS	"p6vmainw"
	
	PRINTD( OSD_LOG, "[OSD][OSD_IsWorking]\n" );
	
	HANDLE hCheckMutex = OpenMutex( MUTEX_ALL_ACCESS, false, MWCLASS );
	if( hCheckMutex ){
		CloseHandle( hCheckMutex );
		return true;
	}
	hMutex = CreateMutex( NULL, 0, MWCLASS );
	return false;
}


////////////////////////////////////////////////////////////////
// W[pX擾
//
// :	Ȃ
// Ԓl:	char *		擾ւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetModulePath( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetModulePath]\n" );
	
	static char mpath[PATH_MAX] = "";	// W[pX擾p
	
	char Drive[3];
	char Dir[PATH_MAX];
	
	int num = GetModuleFileName( NULL, mpath, PATH_MAX );
	_splitpath( mpath, Drive, Dir, NULL, NULL );
	sprintf( mpath, "%s%s", Drive, Dir );
	if( num ) Delimiter( mpath );
	AddDelimiter( mpath );	// Ô
	
	return mpath;
}


////////////////////////////////////////////////////////////////
// tpXt@C擾
//
// :	path		tpXi[obt@|C^
// Ԓl:	char *		t@C̊Jn|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetFileNamePart( const char *path )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetFileNamePart]\n" );
	
	char Drive[3];
	char Dir[PATH_MAX];
	
	_splitpath( path, Drive, Dir, NULL, NULL );
	
	return &path[strlen( Drive ) + strlen( Dir )];
}


////////////////////////////////////////////////////////////////
// t@C̑݃`FbN
//
// :	path		tpXi[obt@|C^
// Ԓl:	bool		true:݂ false:݂Ȃ
////////////////////////////////////////////////////////////////
bool OSD_FileExist( const char *fullpath )
{
	PRINTD( OSD_LOG, "[OSD][OSD_FileExist]\n" );
	
	char filename[PATH_MAX+1];
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	bool ret = false;
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DelDelimiter( filename );
	UnDelimiter( filename );
	
	hFind = FindFirstFile( filename, &FindFileData );
	if( hFind != INVALID_HANDLE_VALUE ) ret = true;
	FindClose( hFind );
	
	return ret;
}


////////////////////////////////////////////////////////////////
// t@C̓ǎp`FbN
//
// :	path		tpXi[obt@|C^
// Ԓl:	bool		true:ǎp false:ǂݏ
///////////////////////////////////////////////////////////////
bool OSD_FileReadOnly( const char *fullpath )
{
	PRINTD( OSD_LOG, "[OSD][OSD_FileReadOnly]\n" );
	
	char filename[PATH_MAX+1];
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DelDelimiter( filename );
	UnDelimiter( filename );
	
	DWORD fa = GetFileAttributes( filename );
	
	if( fa & FILE_ATTRIBUTE_READONLY ) return true;
	else                               return false;
}


///////////////////////////////////////////////////////////
// tH_̎Q
//
// :	hwnd		ẽEBhEnh
//			Result		tH_ւ̃pXi[obt@|C^
// Ԓl:	char *		擾ւ̃|C^
///////////////////////////////////////////////////////////
const char *OSD_FolderDiaog( void *hwnd, char *Result )
{
	LPMALLOC Memory;
	LPITEMIDLIST Ret, Root;
	char Buffer[PATH_MAX];
	
	// VFIMallocC^tF[XɃ|C^擾
	SHGetMalloc( &Memory );
	
	//u}CRs[^vtH_̈ʒu擾
	SHGetSpecialFolderLocation( (HWND)hwnd, CSIDL_DRIVES, &Root );
	
	// tH_̃pX
	UnDelimiter( Result );
	
	//BrowseInfo\̂̏ݒ
	ZeroMemory( &OBI, sizeof(BROWSEINFO) );
	OBI.hwndOwner = (HWND)hwnd;			// eEChẼnh
	OBI.pidlRoot  = Root;				// [gtH_(CSIDL_~~)
	OBI.ulFlags   = BIF_STATUSTEXT | BIF_RETURNONLYFSDIRS;	// tH_̃^CvtO(BIF_~~)
	OBI.lpszTitle = "tH_IĂB";			// ^Cgij
	OBI.pszDisplayName = Buffer;		// (߂l)tH_
	OBI.lpfn = OsdBrowseCallbackProc;	// R[obN֐̃Gg|Cg
	OBI.lParam = (LPARAM)Result;		// R[obN֐ɓn
    	
	//utH_̎QƁv_CAO\
	Ret = SHBrowseForFolder( &OBI );
	
	if( SHGetPathFromIDList( Ret, Buffer ) ){
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		lstrcpyn( Result, Buffer, PATH_MAX-1 );
		DelDelimiter( Result );
		UnDelimiter( Result );
		return Result;
	}else{
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		return NULL;
	}
}

// OSD_FolderDiaog()ŎgpR[obNvV[W
static int CALLBACK OsdBrowseCallbackProc( HWND hwnd, UINT msg, LPARAM lp1, LPARAM lp2 )
{
	char Path[PATH_MAX*2];	// Ô2{?
	
	// BIF_STATUSTEXTȊO͉Ȃ
	if( OBI.ulFlags & BIF_STATUSTEXT ){
		switch( msg ){
		case BFFM_INITIALIZED:	// 
			// tH_ݒ
			SendMessage( hwnd, BFFM_SETSELECTION, (WPARAM)true, lp2 );
			break;
		case BFFM_SELCHANGED:	// [U[tH_ύX
			// ITEMIDLIST\̂pXo
			SHGetPathFromIDList( (LPCITEMIDLIST)lp1, Path );
			// ύXꂽtH_̃pX\
			SendMessage( hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)Path );
		}
	}
	return 0;
}


///////////////////////////////////////////////////////////
// t@C̎Q
//
// :	hwnd		ẽEBhEnh
//			mode		[h FM_Load:t@CJ FM_Save:Otĕۑ
//			title		EBhELvVւ̃|C^
//			filter		t@CtB^ւ̃|C^
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
//			ext			gqւ̃|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
///////////////////////////////////////////////////////////
const char *OSD_FileDiaog( void *hwnd, FileMode mode, const char *title, const char *filter, char *fullpath, char *path, const char *ext )
{
	OPENFILENAME fname;
	char File[PATH_MAX] = "";
	char Path[PATH_MAX] = "";
	bool ret = false;
	
	if( !fullpath ) return NULL;
	
	if( OSD_FileExist( fullpath ) ){
		strncpy( File, fullpath, PATH_MAX );
		UnDelimiter( File );
	}else if( path ){
		strncpy( Path, path,     PATH_MAX );
		UnDelimiter( Path );
	}
	
	ZeroMemory( &fname, sizeof(OPENFILENAME) );
	
	fname.lStructSize     = sizeof(OPENFILENAME);
	fname.hwndOwner       = (HWND)hwnd;		// ẽEBhEnh
	fname.lpstrFilter     = filter;			// t@CtB^
	fname.nFilterIndex    = 1;				// 1Ԗڂ̃t@CtB^g
	fname.lpstrFile       = File;			// IꂽtpX̊i[
	fname.nMaxFile        = sizeof(File);	// ̃TCY
	fname.lpstrInitialDir = Path;			// tH_
	fname.lpstrTitle      = title;			// ^Cg
	fname.lpstrDefExt     = ext;			// gqȗĂꍇɒǉgq
//	fname.Flags           = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
	
	if( mode == FM_Save ){
		fname.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetSaveFileName( &fname );
	}else{
		fname.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetOpenFileName( &fname );
	}
	
	if( ret ){
		Delimiter( File );
		// pXۑ
		if( path ){
			strncpy( path, File, fname.nFileOffset );
			path[fname.nFileOffset] = 0;
		}
		// tpXۑ
		if( fullpath ) strncpy( fullpath, File, PATH_MAX );
		// t@Cւ̃|C^Ԃ
		return fullpath + fname.nFileOffset;
	}else
		return NULL;
}


////////////////////////////////////////////////////////////////
// et@CI
//
// :	hwnd		ẽEBhEnh(NULL̏ꍇ̓XN[T[tFX̃nh擾݂)
//			type		_CAO̎(FileDlgQ)
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
////////////////////////////////////////////////////////////////
const char *OSD_FileSelect( void *hwnd, FileDlg type, char *fullpath, char *path )
{
	HWND shwnd    = (HWND)hwnd;
	FileMode mode = FM_Load;
	const char *title   = NULL;
	const char *filter  = NULL;
	const char *ext     = NULL;
	
	switch( type ){
	case FD_TapeLoad:	// TAPE(LOAD)I
		mode   = FM_Load;
		title  = "TAPEC[WI(LOAD)";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_TapeSave:	// TAPE(SAVE)I
		mode   = FM_Save;
		title  = "TAPEC[WI(SAVE)";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_Disk:		// DISKI
		mode   = FM_Load;
		title  = "DISKC[WI";
		filter = "DISKC[W\0*.d88\0"
				 "D88` (*.d88)\0*.d88\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "d88";
		break;
		
	case FD_ExtRom:		// gROMI
		mode   = FM_Load;
		title  = "gROMC[WI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
		
	case FD_Printer:	// v^[o̓t@CI
		mode   = FM_Save;
		title  = "v^[o̓t@CI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		ext    = "txt";
		break;
		
	case FD_FontZ:		// SptHgt@CI
		mode   = FM_Load;
		title  = "SptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_FontH:		// ptHgt@CI
		mode   = FM_Load;
		title  = "ptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_DokoLoad:	// ǂłLOADt@CI
		mode   = FM_Load;
		title  = "ǂłLOADt@CI";
		filter = "ǂłSAVEt@C\0*.dds;*.ddr\0"
				 "ǂłSAVE` (*.dds)\0*.dds\0"
				 "vCt@C (*.ddr)\0*.ddr\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	case FD_DokoSave:	// ǂłSAVEt@CI
		mode   = FM_Save;
		title  = "ǂłSAVEt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	case FD_RepLoad:	// vCĐt@CI
		mode   = FM_Load;
		title  = "vCĐt@CI";
		filter = "vCt@C (*.ddr)\0*.ddr\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "ddr";
		break;
		
	case FD_RepSave:	// vCۑt@CI
		mode   = FM_Save;
		title  = "vCۑt@CI";
		filter = "vCt@C (*.ddr)\0*.ddr\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "ddr";
		break;
		
	case FD_AVISave:	// rfILv`o̓t@CI
		mode   = FM_Save;
		title  = "rfILv`o̓t@CI";
		filter = "AVIt@C (*.avi)\0*.avi\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "avi";
		break;
		
	case FD_LoadAll:	// ėpLOAD
	default:
		mode   = FM_Load;
		title  = "t@CI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
	}
	
	// EBhEnh NULL ,XN[T[tFX̃nh擾݂
//	if( !hwnd ){
//		SDL_SysWMinfo WinInfo;
//		SDL_VERSION( &WinInfo.version );
//		shwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
//	}
	
	return OSD_FileDiaog( shwnd, mode, title, filter, fullpath, path, ext );
}


////////////////////////////////////////////////////////////////
// bZ[W\
//
// :	mes			bZ[Wւ̃|C^
//			cap			EBhELvVւ̃|C^
//			type		\`w̃tO
// Ԓl:	int			ꂽ{^̎
//							OSDR_OK:     OK{^
//							OSDR_CANCEL: CANCEL{^
//							OSDR_YES:    YES{^
//							OSDR_NO:     NO{^
////////////////////////////////////////////////////////////////
int OSD_Message( const char *mes, const char *cap, int type )
{
	int Type = MB_OK;
	
	// bZ[W{bNX̃^Cv
	switch( type&0x000f ){
	case OSDM_OK:			Type = MB_OK;			break;
	case OSDM_OKCANCEL:		Type = MB_OKCANCEL;		break;
	case OSDM_YESNO:		Type = MB_YESNO;		break;
	case OSDM_YESNOCANCEL:	Type = MB_YESNOCANCEL;	break;
	}
	
	// bZ[W{bNX̃ACR^Cv
	switch( type&0x00f0 ){
	case OSDM_ICONERROR:	Type |= MB_ICONERROR;		break;
	case OSDM_ICONQUESTION:	Type |= MB_ICONQUESTION;	break;
	case OSDM_ICONWARNING:	Type |= MB_ICONWARNING;		break;
	case OSDM_ICONINFO:		Type |= MB_ICONINFORMATION;	break;
	}
	
	// eEBhE̓XN[T[tFXƌߑł
//	SDL_SysWMinfo WinInfo;
//	SDL_VERSION( &WinInfo.version );
//	HWND hwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	
//	int res = MessageBox( hwnd, mes, cap, Type | MB_TOPMOST );
	int res = MessageBox( NULL, mes, cap, Type | MB_TOPMOST );
	
	switch( res ){
	case IDOK:	return OSDR_OK;
	case IDYES:	return OSDR_YES;
	case IDNO:	return OSDR_NO;
	default:	return OSDR_CANCEL;
	}
}




////////////////////////////////////////////////////////////////
// L[s[gݒ
//
// :	repeat	L[s[g̊Ԋu(ms) 0Ŗ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_SetKeyRepeat( int repeat )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	// SDL2.0ɂ̓L[s[g̐ݒ肪Ȃ炵
	#else
	SDL_EnableKeyRepeat( 500, repeat );
	#endif
}


////////////////////////////////////////////////////////////////
// OSDL[R[h -> zL[R[hϊ
//
// :	scode		ˑ̃L[R[h
// Ԓl:	PCKEYsym	zL[R[h
////////////////////////////////////////////////////////////////
PCKEYsym OSD_ConvertKeyCode( int scode )
{
	return VKTable[scode];
}


////////////////////////////////////////////////////////////////
// p\ȃWCXeBbN擾
//
// :	Ȃ
// Ԓl:	int			p\ȃWCXeBbN
////////////////////////////////////////////////////////////////
int OSD_GetJoyNum( void )
{
	return SDL_NumJoysticks();
}


////////////////////////////////////////////////////////////////
// WCXeBbN擾
//
// :	int			CfbNX
// Ԓl:	char *		WCXeBbNւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetJoyName( int index )
{
	return SDL_JoystickName( index );
}


////////////////////////////////////////////////////////////////
// WCXeBbNI[vĂH
//
// :	int			CfbNX
// Ԓl:	bool		true:OPEN false:CLOSE
////////////////////////////////////////////////////////////////
bool OSD_OpenedJoy( int index )
{
	return SDL_JoystickOpened( index ) ? true : false;
}


////////////////////////////////////////////////////////////////
// WCXeBbNI[v
//
// :	int			CfbNX
// Ԓl:	HJOYINFO	WCXeBbNւ̃|C^
////////////////////////////////////////////////////////////////
HJOYINFO OSD_OpenJoy( int index )
{
	return (HJOYINFO)SDL_JoystickOpen( index );
}


////////////////////////////////////////////////////////////////
// WCXeBbNN[Y
//
// :	int			CfbNX
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_CloseJoy( HJOYINFO jinfo )
{
	SDL_JoystickClose( (SDL_Joystick *)jinfo );
}


////////////////////////////////////////////////////////////////
// WCXeBbN̎̐擾
//
// :	HJOYINFO	WCXeBbNւ̃|C^
// Ԓl:	int			̐
////////////////////////////////////////////////////////////////
int OSD_GetJoyNumAxes( HJOYINFO jinfo )
{
	return SDL_JoystickNumAxes( (SDL_Joystick *)jinfo );
}


////////////////////////////////////////////////////////////////
// WCXeBbÑ{^̐擾
//
// :	HJOYINFO	WCXeBbNւ̃|C^
// Ԓl:	int			{^̐
////////////////////////////////////////////////////////////////
int OSD_GetJoyNumButtons( HJOYINFO jinfo )
{
	return SDL_JoystickNumButtons( (SDL_Joystick *)jinfo );
}


////////////////////////////////////////////////////////////////
// WCXeBbN̎̏Ԏ擾
//
// :	HJOYINFO	WCXeBbNւ̃|C^
//			int			̔ԍ
// Ԓl:	int			̏(-32768`32767)
////////////////////////////////////////////////////////////////
int OSD_GetJoyAxis( HJOYINFO jinfo, int num )
{
	return SDL_JoystickGetAxis( (SDL_Joystick *)jinfo, num );
}


////////////////////////////////////////////////////////////////
// WCXeBbÑ{^̏Ԏ擾
//
// :	HJOYINFO	WCXeBbNւ̃|C^
//			int			{^̔ԍ
// Ԓl:	bool		{^̏ true:ON false:OFF
////////////////////////////////////////////////////////////////
bool OSD_GetJoyButton( HJOYINFO jinfo, int num )
{
	return SDL_JoystickGetButton( (SDL_Joystick *)jinfo, num ) ? true : false;
}


////////////////////////////////////////////////////////////////
// I[fBIfoCXI[v
//
// :	obj			gւ̃IuWFNg|C^
//			callback	R[obN֐ւ̃|C^
//			rate		TvO[g
//			sample		obt@TCY(Tv)
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_OpenAudio( void *obj, CBF_SND callback, int rate, int samples )
{
	SDL_AudioSpec ASpec;				// I[fBIXybN
	
	ASpec.freq     = rate;				// TvO[g
	ASpec.format   = AUDIOFORMAT;		// tH[}bg
	ASpec.channels = 1;					// m
	ASpec.samples  = samples;			// obt@TCY(Tv)
	ASpec.callback = callback;			// R[obN֐̎w
	ASpec.userdata = obj;				// R[obN֐Ɏg̃IuWFNg|C^n
	
	// I[fBIfoCXJ
	if( SDL_OpenAudio( &ASpec, NULL ) < 0 ) return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// I[fBIfoCXN[Y
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_CloseAudio( void )
{
	SDL_CloseAudio();
}


////////////////////////////////////////////////////////////////
// ĐJn
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_StartAudio( void )
{
	SDL_PauseAudio( 0 );
}


////////////////////////////////////////////////////////////////
// Đ~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_StopAudio( void )
{
	SDL_PauseAudio( 1 );
}


////////////////////////////////////////////////////////////////
// ĐԎ擾
//
// :	Ȃ
// Ԓl:	bool		true:Đ false:~
////////////////////////////////////////////////////////////////
bool OSD_AudioPlaying( void )
{
	return SDL_GetAudioStatus() == SDL_AUDIO_PLAYING ? true : false;
}


////////////////////////////////////////////////////////////////
// Wavet@CǍ
// @Ή` 22050Hzȏ,t16bit,1ch
//
// :	filepath	t@CpX
//			buf			obt@|C^i[|C^
//			len			t@Ci[|C^
//			freq		TvO[gi[|C^
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_LoadWAV( const char *filepath, BYTE **buf, DWORD *len, int *freq )
{
	SDL_AudioSpec ws;
	
	if( !SDL_LoadWAV( filepath, &ws, buf, (Uint32 *)len ) ) return false;
	
	if( ws.freq < 22050 || ws.format != AUDIO_S16 || ws.channels != 1 ){
		SDL_FreeWAV( *buf );
		return false;
	}
	
	*freq    = ws.freq;
	
	return true;
}


////////////////////////////////////////////////////////////////
// Wavet@CJ
//
// :	buf			obt@ւ̃|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_FreeWAV( BYTE *buf )
{
	SDL_FreeWAV( buf );
}


////////////////////////////////////////////////////////////////
// w莞ԑҋ@
//
// :	tms			ҋ@(ms)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_Delay( DWORD tms )
{
	#ifdef USESDLTIMER
	SDL_Delay( tms );
	#else
	Sleep( tms );
	#endif
}


////////////////////////////////////////////////////////////////
// vZXJňoߎԎ擾
//
// :	Ȃ
// Ԓl:	DWORD		oߎ(ms)
////////////////////////////////////////////////////////////////
DWORD OSD_GetTicks( void )
{
	#ifdef USESDLTIMER
	return SDL_GetTicks();
	#else
	return GetTickCount();
	#endif
}


////////////////////////////////////////////////////////////////
// ^C}ǉ
//
// :	interval	݊Ԋu(ms)
//			callback	R[obN֐
//			param		R[obN֐ɓn
// Ԓl:	HTIMERID	^C}ID(sNULL)
////////////////////////////////////////////////////////////////
HTIMERID OSD_AddTimer( DWORD interval, CBF_TMR callback, void *param )
{
	#ifdef USESDLTIMER
	#if SDL_VERSION_ATLEAST(2,0,0)
	SDL_TimerID *pid = NULL;
	SDL_TimerID tid = SDL_AddTimer( interval, (SDL_TimerCallback)callback, param );
	if( tid ){
		pid = new SDL_TimerID;
		if( pid ) *pid = tid;
	}
	return (HTIMERID)pid;
	#else
	return (HTIMERID)SDL_AddTimer( interval, (SDL_NewTimerCallback)callback, param );
	#endif
	#else
	TINFO *tinfo = new TINFO;
	if( !tinfo ) return NULL;
	
	timeBeginPeriod( TIMERRES );
	tinfo->interval = interval;
	tinfo->callback = callback;
	tinfo->param    = param;
	tinfo->id       = timeSetEvent( interval, 1, OsdTimerCallbackProc, 0, TIME_PERIODIC );
	if( !tinfo->id ){
		delete tinfo;
		timeEndPeriod( TIMERRES );
		return NULL;
	}
	
	TINFO *ti = tif;
	if( !ti ) tif = tinfo;
	else{
		while( ti->next ) ti = ti->next;
		ti->next = tinfo;
	}
	
	return (HTIMERID)tinfo;
	#endif
}

#ifndef USESDLTIMER
// OSD_AddTimer()ŎgpR[obNvV[W
static void CALLBACK OsdTimerCallbackProc( UINT id,  UINT, DWORD_PTR data, DWORD_PTR, DWORD_PTR )
{
	TINFO *ti = tif;
	
	while( ti && (ti->id != id) ) ti = ti->next;
	if( ti ) ti->callback( ti->interval, ti->param );
}
#endif


////////////////////////////////////////////////////////////////
// ^C}폜
//
// :	id			^C}ID
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_DelTimer( HTIMERID id )
{
	#ifdef USESDLTIMER
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( SDL_RemoveTimer( *((SDL_TimerID *)id) ) ){
		delete (SDL_TimerID *)id;
		return true;
	}else
		return false;
	#else
	return (bool)SDL_RemoveTimer( (SDL_TimerID)id );
	#endif
	#else
	if( !id ) return false;
	
	TINFO *tinfo = (TINFO *)id;
	TINFO *ti    = tif;
	TINFO *tip   = NULL;
	
	while( ti && (ti->id != tinfo->id) ){
		tip = ti;
		ti  = ti->next;
	}
	if( !ti ) return false;
	
	if( timeKillEvent( ti->id ) != TIMERR_NOERROR )
		return false;
	timeEndPeriod( TIMERRES );
	
	delete ti;
	if( tip ) tip->next = NULL;
	else      tif = NULL;
	
	return true;
	#endif
}


////////////////////////////////////////////////////////////////
// LvVݒ
//
// :	wh			EBhEnh
//			str			LvVւ̃|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_SetWindowCaption( HWINDOW wh, const char *str )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( wh && str ) SDL_SetWindowTitle( (SDL_Window*)wh, str );
	#else
	if( str ) SDL_WM_SetCaption( str, "" );
	#endif
}


////////////////////////////////////////////////////////////////
// }EXJ[\\/\
//
// :	disp		true:\ false:\
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_ShowCursor( bool disp )
{
	SDL_ShowCursor( disp ? SDL_ENABLE : SDL_DISABLE );
}


////////////////////////////////////////////////////////////////
// EBhE쐬
//
// :	pwh			EBhEnhւ̃|C^
//			w			
//			h			
//			bpp			F[x
//			fsflag		true:tXN[ false:EBhE
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_CreateWindow( HWINDOW *pwh, int w, int h, int bpp, bool fsflag )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( !*pwh ){
		*pwh = (HWINDOW)SDL_CreateWindow( "", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, w, h,
											SDL_WINDOW_SHOWN );
		if( !*pwh ) return false;
	}
	
	SDL_Renderer *rend = SDL_GetRenderer( (SDL_Window *)*pwh );
	if( rend ) SDL_DestroyRenderer( rend );
	
	if( fsflag ){
		SDL_DisplayMode mode;
		
		mode.format = bpp ==  8 ? SDL_PIXELFORMAT_INDEX8 :
					  bpp == 16 ? SDL_PIXELFORMAT_RGB555 :
								  SDL_PIXELFORMAT_RGB24;
		mode.w = w;
		mode.h = h;
		mode.refresh_rate = 0;
		mode.driverdata   = 0;
		SDL_SetWindowDisplayMode( (SDL_Window *)*pwh, &mode );
		SDL_SetWindowFullscreen( (SDL_Window *)*pwh, SDL_TRUE );
	}else{
		SDL_SetWindowFullscreen( (SDL_Window *)*pwh, SDL_FALSE );
		SDL_SetWindowSize( (SDL_Window *)*pwh, w, h );
	}
	
	rend = SDL_CreateRenderer( (SDL_Window *)*pwh, -1, SDL_RENDERER_ACCELERATED );
	#else
	*pwh = (HWINDOW)SDL_SetVideoMode( w, h, bpp, SDLOP_SCREEN | (fsflag ? SDL_FULLSCREEN : 0) );
	#endif
	return *pwh ? true : false;
}


////////////////////////////////////////////////////////////////
// EBhEj
//
// :	wh			EBhEnh
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_DestroyWindow( HWINDOW wh )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( wh ){
		SDL_Renderer *rend = SDL_GetRenderer( (SDL_Window *)wh );
		if( rend ) SDL_DestroyRenderer( rend );
		SDL_DestroyWindow( (SDL_Window *)wh );
	}
	#else
	// SDL1.2͖
	#endif
}


////////////////////////////////////////////////////////////////
// EBhE̕擾
//
// :	wh			EBhEnh
// Ԓl:	int			
////////////////////////////////////////////////////////////////
int OSD_GetWindowWidth( HWINDOW wh )
{
	int res = 0;
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( wh ) SDL_GetWindowSize( (SDL_Window *)wh, &res, NULL );
	#else
	if( wh ) res = ((SDL_Surface *)wh)->w;
	#endif
	return res;
}


////////////////////////////////////////////////////////////////
// EBhE̍擾
//
// :	wh			EBhEnh
// Ԓl:	int			
////////////////////////////////////////////////////////////////
int OSD_GetWindowHeight( HWINDOW wh )
{
	int res = 0;
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( wh ) SDL_GetWindowSize( (SDL_Window *)wh, NULL, &res );
	#else
	if( wh ) res = ((SDL_Surface *)wh)->h;
	#endif
	return res;
}


////////////////////////////////////////////////////////////////
// EBhE̐F[x擾
//
// :	wh			EBhEnh
// Ԓl:	int			F[x
////////////////////////////////////////////////////////////////
int OSD_GetWindowBPP( HWINDOW wh )
{
	int res = 0;
	#if SDL_VERSION_ATLEAST(2,0,0)
	if( wh ) res = (SDL_GetWindowSurface( (SDL_Window *)wh ))->format->BitsPerPixel;
	#else
	if( wh ) res = ((SDL_Surface *)wh)->format->BitsPerPixel;
	#endif
	return res;
}


////////////////////////////////////////////////////////////////
// pbgݒ
//
// :	wh			EBhEnh
//			pal			pbgւ̃|C^
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_SetPalette( HWINDOW wh, VPalette *pal )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	return SDL_SetSurfacePalette( SDL_GetWindowSurface( (SDL_Window *)wh ), (SDL_Palette *)pal ) ? false : true;
	#else
	return SDL_SetPalette( (SDL_Surface *)wh, SDL_LOGPAL|SDL_PHYSPAL, (SDL_Color *)pal->colors, 0, pal->ncols ) ? false : true;
	#endif
}


////////////////////////////////////////////////////////////////
// EBhENA
//  F0()Ōߑł
//
// :	wh			EBhEnh
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_ClearWindow( HWINDOW wh )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	SDL_Renderer *rend = SDL_GetRenderer( (SDL_Window *)wh );
	SDL_SetRenderDrawColor( rend, 0, 0, 0, 0xff );
	SDL_RenderClear( rend );

//	SDL_Surface *sur = SDL_GetWindowSurface( (SDL_Window *)wh );
//	SDL_FillRect( sur, NULL, SDL_MapRGB( sur->format, 0, 0, 0 ) );

	#else
	SDL_FillRect( (SDL_Surface *)wh, NULL, 0 );
	#endif
}


////////////////////////////////////////////////////////////////
// EBhEf
//
// :	wh			EBhEnh
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_RenderWindow( HWINDOW wh )
{
	#if SDL_VERSION_ATLEAST(2,0,0)
	SDL_Renderer *rend = SDL_GetRenderer( (SDL_Window *)wh );
	SDL_RenderPresent( rend );

//	SDL_UpdateWindowSurface( (SDL_Window *)wh );

	#else
 	SDL_Flip( (SDL_Surface *)wh );
	#endif

}


////////////////////////////////////////////////////////////////
// EBhEɓ]
//
// :	wh			EBhEnh
//			src			]T[tFX
//			pal			pbgւ̃|C^
//			x,y			]W
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_BlitToWindow( HWINDOW wh, VSurface *src, int x, int y, VPalette *pal )
{
	VRect src1,drc1;
	
	if( !src || !wh ) return;
	#if SDL_VERSION_ATLEAST(2,0,0)
	SDL_Surface *dst  = SDL_GetWindowSurface( (SDL_Window *)wh );
	#else
	SDL_Surface *dst  = SDL_GetVideoSurface();
	#endif
	
	// ]͈͐ݒ
	src1.x = max( 0, -x );
	src1.y = max( 0, -y );
	src1.w = min( src->Width()  - src1.x, dst->w );
	src1.h = min( src->Height() - src1.y, dst->h );
	
	if( src1.w <= 0 || src1.h <= 0 ) return;
	
	// ]͈͐ݒ
	drc1.x = max( 0, x );
	drc1.y = max( 0, y );
	
	
	if( SDL_MUSTLOCK( dst ) ) SDL_LockSurface( dst );
	
	BYTE *psrc = (BYTE *)src->GetPixels() + src->Pitch() * src1.y + src1.x * src->Bpp() / 8;
	BYTE *pdst = (BYTE *)dst->pixels      + dst->pitch   * drc1.y + drc1.x * dst->format->BytesPerPixel;
	
	if( src->Bpp() == dst->format->BitsPerPixel ){
		for( int i=0; i < src1.h; i++ ){
			memcpy( pdst, psrc, src1.w * dst->format->BytesPerPixel );
			psrc += src->Pitch();
			pdst += dst->pitch;
		}
	}else if( src->Bpp() == 8 && dst->format->BitsPerPixel == 16 ){	// 8 -> 16 bpp (5:6:5)
		for( int i=0; i < src1.h; i++ ){
			for( int j=0; j < src1.w; j++ ){
				WORD wdat = (WORD)(pal->colors[*psrc].r & 0xf8) << 8
				          | (WORD)(pal->colors[*psrc].g & 0xfc) << 3
				          | (WORD)(pal->colors[*psrc].b & 0xf8) >> 3;
				*pdst++ = (BYTE)( wdat       & 0xff);
				*pdst++ = (BYTE)((wdat >> 8) & 0xff);
				psrc++;
			}
			psrc += src->Pitch() - src1.w;
			pdst += dst->pitch   - src1.w * 2;
		}
	}else if( src->Bpp() == 8 && dst->format->BitsPerPixel == 24 ){	// 8 -> 24 bpp
		for( int i=0; i < src1.h; i++ ){
			for( int j=0; j < src1.w; j++ ){
				*pdst++ = pal->colors[*psrc].b;
				*pdst++ = pal->colors[*psrc].g;
				*pdst++ = pal->colors[*psrc].r;
				psrc++;
			}
			psrc += src->Pitch() - src1.w;
			pdst += dst->pitch   - src1.w * 3;
		}
	}
	
	if( SDL_MUSTLOCK( dst ) ) SDL_UnlockSurface( dst );
}


////////////////////////////////////////////////////////////////
// EBhEɓ](2{)
//
// :	wh			EBhEnh
//			src			]T[tFX
//			x,y			]W
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_BlitToWindow2( HWINDOW wh, VSurface *src, int x, int y )
{
	VRect src1,drc1;
	
	if( !src || !wh ) return;
	#if SDL_VERSION_ATLEAST(2,0,0)
	SDL_Surface *dst  = SDL_GetWindowSurface( (SDL_Window *)wh );
	#else
	SDL_Surface *dst  = SDL_GetVideoSurface();
	#endif
	
	// ]͈͐ݒ
	src1.x = max( 0, -x/2 );
	src1.y = max( 0, -y/2 );
	src1.w = min( src->Width()  - src1.x, dst->w / 2 );
	src1.h = min( src->Height() - src1.y, dst->h / 2 );
	
	if( src1.w <= 0 || src1.h <= 0 ) return;
	
	// ]͈͐ݒ
	drc1.x = max( 0, x );
	drc1.y = max( 0, y );
	
	
	if( SDL_MUSTLOCK( dst ) ) SDL_LockSurface( dst );
	
	BYTE *psrc = (BYTE *)src->GetPixels() + src->Pitch() * src1.y + src1.x * src->Bpp() / 8;
	BYTE *pdst = (BYTE *)dst->pixels      + dst->pitch   * drc1.y + drc1.x * dst->format->BytesPerPixel;
	
	if( src->Bpp() == dst->format->BitsPerPixel ){
		switch( src->Bpp() ){
		case 8:
			for( int i=0; i < src1.h; i++ ){
				for( int j=0; j < src1.w; j++ ){
					*pdst++ = *psrc;
					*pdst++ = *psrc++;
				}
				psrc += src->Pitch()   - src1.w;
				pdst += dst->pitch * 2 - src1.w * 2;
			}
			break;
			
		case 16:
			for( int i=0; i < src1.h; i++ ){
				for( int j=0; j < src1.w; j++ ){
					WORD d1 = *(WORD *)psrc++;
					psrc++;
					*((WORD *)pdst++) = d1;
					pdst++;
					*((WORD *)pdst++) = d1;
					pdst++;
				}
				psrc += src->Pitch()   - src1.w * 2;
				pdst += dst->pitch * 2 - src1.w * 4;
			}
			break;
			
		case 24:
			for( int i=0; i < src1.h; i++ ){
				for( int j=0; j < src1.w; j++ ){
					BYTE b = *psrc++;
					BYTE g = *psrc++;
					BYTE r = *psrc++;
					*pdst++ = b;
					*pdst++ = g;
					*pdst++ = r;
					*pdst++ = b;
					*pdst++ = g;
					*pdst++ = r;
				}
				psrc += src->Pitch()   - src1.w * 3;
				pdst += dst->pitch * 2 - src1.w * 6;
			}
		}
		
		pdst = (BYTE *)dst->pixels + dst->pitch * drc1.y + drc1.x * dst->format->BytesPerPixel;
		for( int i=0; i < src1.h; i++ ){
			memcpy( pdst + dst->pitch, pdst, src1.w * 2 * dst->format->BytesPerPixel );
			pdst += dst->pitch * 2;
		}
	}
	
	if( SDL_MUSTLOCK( dst ) ) SDL_UnlockSurface( dst );
}


///////////////////////////////////////////////////////////
// ACRݒ
//
// :	wh			EBhEnh
//			model		@ 60,62,66
// Ԓl:	Ȃ
///////////////////////////////////////////////////////////
void OSD_SetIcon( HWINDOW wh, int model )
{
	BYTE *ipix;
	#if SDL_VERSION_ATLEAST(2,0,0)
	switch( model ){
	case 62: ipix = (BYTE *)p62pix; break;
	case 66: ipix = (BYTE *)p66pix; break;
	default: ipix = (BYTE *)p60pix;
	}
	SDL_Surface *p6icon = SDL_CreateRGBSurfaceFrom( ipix, 32, 32, 32, 32*4, 0xff000000, 0x00ff0000, 0x0000ff00, 0x000000ff );
	SDL_SetWindowIcon( (SDL_Window *)wh, p6icon );
	#else
	BYTE *imsk;
	switch( model ){
	case 62: ipix = (BYTE *)p62pix; imsk = (BYTE *)p62msk; break;
	case 66: ipix = (BYTE *)p66pix; imsk = (BYTE *)p66msk; break;
	default: ipix = (BYTE *)p60pix; imsk = (BYTE *)p60msk;
	}
	SDL_Surface *p6icon = SDL_CreateRGBSurfaceFrom( ipix, 32, 32, 24, 32*3, 0, 0, 0, 0 );
	SDL_WM_SetIcon( p6icon, imsk );
	#endif
	SDL_FreeSurface( p6icon );
}





////////////////////////////////////////////////////////////////
// Cxg擾(Cxg܂ő҂)
//
// :	ev			Cxg񋤗p̂ւ̃|C^
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_GetEvent( Event *ev )
{
	SDL_Event event;
	
	if( !SDL_WaitEvent( &event ) ) return false;
	
	switch( event.type ){
	case SDL_KEYDOWN:
		ev->type			= EV_KEYDOWN;
		ev->key.state		= true;
		#if SDL_VERSION_ATLEAST(2,0,0)
		ev->key.sym			= OSD_ConvertKeyCode( event.key.keysym.scancode );
		#else
		ev->key.sym			= OSD_ConvertKeyCode( event.key.keysym.sym );
		#endif
		ev->key.mod			= (PCKEYmod)(
							  ( event.key.keysym.mod & KMOD_LSHIFT ? KVM_LSHIFT : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RSHIFT ? KVM_RSHIFT : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_LCTRL  ? KVM_LCTRL  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RCTRL  ? KVM_RCTRL  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_LALT   ? KVM_LALT   : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RALT   ? KVM_RALT   : KVM_NONE )
							#if SDL_VERSION_ATLEAST(2,0,0)
							| ( event.key.keysym.mod & KMOD_LGUI   ? KVM_LMETA  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RGUI   ? KVM_RMETA  : KVM_NONE )
							#else
							| ( event.key.keysym.mod & KMOD_LMETA  ? KVM_LMETA  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RMETA  ? KVM_RMETA  : KVM_NONE )
							#endif
							| ( event.key.keysym.mod & KMOD_NUM    ? KVM_NUM    : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_CAPS   ? KVM_CAPS   : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_MODE   ? KVM_MODE   : KVM_NONE ) );
		ev->key.unicode		= event.key.keysym.unicode;
		break;
		
	case SDL_KEYUP:
		ev->type			= EV_KEYUP;
		ev->key.state		= false;
		#if SDL_VERSION_ATLEAST(2,0,0)
		ev->key.sym			= OSD_ConvertKeyCode( event.key.keysym.scancode );
		#else
		ev->key.sym			= OSD_ConvertKeyCode( event.key.keysym.sym );
		#endif
		ev->key.mod			= (PCKEYmod)(
							  ( event.key.keysym.mod & KMOD_LSHIFT ? KVM_LSHIFT : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RSHIFT ? KVM_RSHIFT : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_LCTRL  ? KVM_LCTRL  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RCTRL  ? KVM_RCTRL  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_LALT   ? KVM_LALT   : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RALT   ? KVM_RALT   : KVM_NONE )
							#if SDL_VERSION_ATLEAST(2,0,0)
							| ( event.key.keysym.mod & KMOD_LGUI   ? KVM_LMETA  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RGUI   ? KVM_RMETA  : KVM_NONE )
							#else
							| ( event.key.keysym.mod & KMOD_LMETA  ? KVM_LMETA  : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_RMETA  ? KVM_RMETA  : KVM_NONE )
							#endif
							| ( event.key.keysym.mod & KMOD_NUM    ? KVM_NUM    : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_CAPS   ? KVM_CAPS   : KVM_NONE )
							| ( event.key.keysym.mod & KMOD_MODE   ? KVM_MODE   : KVM_NONE ) );
		ev->key.unicode		= event.key.keysym.unicode;
		break;
		
	case SDL_MOUSEBUTTONDOWN:
		ev->type			= EV_MOUSEBUTTONDOWN;
		ev->mousebt.button	= event.button.button == SDL_BUTTON_LEFT      ? MBT_LEFT      :
							  event.button.button == SDL_BUTTON_MIDDLE    ? MBT_MIDDLE    :
							  event.button.button == SDL_BUTTON_RIGHT     ? MBT_RIGHT     :
//							  event.button.button == SDL_BUTTON_WHEELUP   ? MBT_WHEELUP   :
//							  event.button.button == SDL_BUTTON_WHEELDOWN ? MBT_WHEELDOWN :
							  MBT_NONE;
		ev->mousebt.state	= true;
		ev->mousebt.x		= event.button.x;
		ev->mousebt.y		= event.button.y;
		break;
		
	case SDL_MOUSEBUTTONUP:
		ev->type			= EV_MOUSEBUTTONUP;
		ev->mousebt.button	= event.button.button == SDL_BUTTON_LEFT      ? MBT_LEFT      :
							  event.button.button == SDL_BUTTON_MIDDLE    ? MBT_MIDDLE    :
							  event.button.button == SDL_BUTTON_RIGHT     ? MBT_RIGHT     :
//							  event.button.button == SDL_BUTTON_WHEELUP   ? MBT_WHEELUP   :
//							  event.button.button == SDL_BUTTON_WHEELDOWN ? MBT_WHEELDOWN :
							  MBT_NONE;
		ev->mousebt.state	= false;
		ev->mousebt.x		= event.button.x;
		ev->mousebt.y		= event.button.y;
		break;
		
	case SDL_JOYAXISMOTION:
		ev->type			= EV_JOYAXISMOTION;
		ev->joyax.idx		= event.jaxis.which;
		ev->joyax.axis		= event.jaxis.axis;
		ev->joyax.value		= event.jaxis.value;
		break;
		
	case SDL_JOYBUTTONDOWN:
		ev->type			= EV_JOYBUTTONDOWN;
		ev->joybt.idx		= event.jbutton.which;
		ev->joybt.button	= event.jbutton.button;
		ev->joybt.state		= true;
		break;
		
	case SDL_JOYBUTTONUP:
		ev->type			= EV_JOYBUTTONUP;
		ev->joybt.idx		= event.jbutton.which;
		ev->joybt.button	= event.jbutton.button;
		ev->joybt.state		= false;
		break;
		
	case SDL_QUIT:
		ev->type			= EV_QUIT;
		break;
		
	case UEV_RESTART:
		ev->type			= EV_RESTART;
		break;
		
	case UEV_DOKOLOAD:
		ev->type			= EV_DOKOLOAD;
		break;
		
	case UEV_REPLAY:
		ev->type			= EV_REPLAY;
		break;
		
	case UEV_FPSUPDATE:
		ev->type			= EV_FPSUPDATE;
		ev->fps.fps			= event.user.code;
		break;
		
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	case UEV_DEBUGMODEBP:
		ev->type			= EV_DEBUGMODEBP;
		ev->bp.addr			= event.user.code;
		break;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
	default:
		ev->type			= EV_NOEVENT;
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// CxgL[ɃvbV
//
// :	ev			Cxg^Cv
//			...			Cxg^Cvɉ
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool OSD_PushEvent( EventType ev, ... )
{
	SDL_Event event;
	
	va_list args;
	va_start( args, ev );
	
	#if SDL_VERSION_ATLEAST(2,0,0)
	event.type = SDL_FIRSTEVENT;
	#else
	event.type = SDL_NOEVENT;
	#endif
	
	switch( ev ){
	case EV_QUIT:
		event.type		= SDL_QUIT;
		break;
		
	case EV_RESTART:
		event.type		= UEV_RESTART;
		break;
		
	case EV_DOKOLOAD:
		event.type		= UEV_DOKOLOAD;
		break;
		
	case EV_REPLAY:
		event.type		= UEV_REPLAY;
		break;
		
	case EV_FPSUPDATE:
		event.type		= UEV_FPSUPDATE;
		event.user.code	= va_arg( args, int );
		break;
		
	case EV_DEBUGMODEBP:
		event.type		= UEV_DEBUGMODEBP;
		event.user.code	= va_arg( args, int );
		break;
		
	default:
		return false;
	}
	
	va_end( args );
	
	return SDL_PushEvent( &event ) ? false : true;
}



////////////////////////////////////////////////////////////////
// F̖O擾
//
// :	num			FR[h
// Ԓl:	char *		F̖Oւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_ColorName( int num )
{
	static const char *JColorName[] = {
		"MODE1,2 ({[_[)",
		"MODE1 Set1 ",		"MODE1 Set1 [",		"MODE1 Set2 ",		"MODE1 Set2 [",
		"MODE2 ",				"MODE2 ",				"MODE2 ",				"MODE2 ",
		"MODE2 ",				"MODE2 VA",			"MODE2 }[^",		"MODE2 ",
		"MODE3 Set1 ",		"MODE3 Set1 ",		"MODE3 Set1 ",		"MODE3 Set1 ",
		"MODE3 Set2 ",		"MODE3 Set2 VA",	"MODE3 Set2 }[^",	"MODE3 Set2 ",
		"MODE4 Set1 [",		"MODE4 Set1 ",		"MODE4 Set2 ",		"MODE4 Set2 ",
		"MODE4 Set1 ɂ ",	"MODE4 Set1 ɂ ",	"MODE4 Set1 ɂ -",	"MODE4 Set1 ɂ -",
		"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",
		"mk2` ()",		"mk2` ",				"mk2` ",			"mk2` ",
		"mk2` ",			"mk2` Ԏ",			"mk2` F",			"mk2` DF",
		"mk2` ",				"mk2` ",				"mk2` ",				"mk2` ",
		"mk2` ",				"mk2` }[^",		"mk2` VA",			"mk2` " };
	
	if( num < 0 || num >= COUNTOF( JColorName ) ) return NULL;
	else                                          return JColorName[num];

}


////////////////////////////////////////////////////////////////
// L[̖O擾
//
// :	sym			zL[R[h
// Ԓl:	char *		L[Oւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_KeyName( PCKEYsym sym )
{
	static const PCKeyName kname[] = {
		{ KVC_1,			"1" },
		{ KVC_2,			"2" },
		{ KVC_3,			"3" },
		{ KVC_4,			"4" },
		{ KVC_5,			"5" },
		{ KVC_6,			"6" },
		{ KVC_7,			"7" },
		{ KVC_8,			"8" },
		{ KVC_9,			"9" },
		{ KVC_0,			"0" },
		
		{ KVC_A,			"A" },
		{ KVC_B,			"B" },
		{ KVC_C,			"C" },
		{ KVC_D,			"D" },
		{ KVC_E,			"E" },
		{ KVC_F,			"F" },
		{ KVC_G,			"G" },
		{ KVC_H,			"H" },
		{ KVC_I,			"I" },
		{ KVC_J,			"J" },
		{ KVC_K,			"K" },
		{ KVC_L,			"L" },
		{ KVC_M,			"M" },
		{ KVC_N,			"N" },
		{ KVC_O,			"O" },
		{ KVC_P,			"P" },
		{ KVC_Q,			"Q" },
		{ KVC_R,			"R" },
		{ KVC_S,			"S" },
		{ KVC_T,			"T" },
		{ KVC_U,			"U" },
		{ KVC_V,			"V" },
		{ KVC_W,			"W" },
		{ KVC_X,			"X" },
		{ KVC_Y,			"Y" },
		{ KVC_Z,			"Z" },
		
		{ KVC_F1,			"F1" },
		{ KVC_F2,			"F2" },
		{ KVC_F3,			"F3" },
		{ KVC_F4,			"F4" },
		{ KVC_F5,			"F5" },
		{ KVC_F6,			"F6" },
		{ KVC_F7,			"F7" },
		{ KVC_F8,			"F8" },
		{ KVC_F9,			"F9" },
		{ KVC_F10,			"F10" },
		{ KVC_F11,			"F11" },
		{ KVC_F12,			"F12" },
		
		{ KVC_MINUS,		"-" },
		{ KVC_CARET,		"^" },
		{ KVC_BACKSPACE,	"BackSpace" },
		{ KVC_AT,			"@" },
		{ KVC_LBRACKET,		"[" },
		{ KVC_SEMICOLON,	";" },
		{ KVC_COLON,		":" },
		{ KVC_COMMA,		"," },
		{ KVC_PERIOD,		"." },
		{ KVC_SLASH,		"/" },
		{ KVC_SPACE,		"Space" },
		
		{ KVC_ESC,			"ESC" },
		{ KVC_HANZEN,		"p/Sp" },
		{ KVC_TAB,			"Tab" },
		{ KVC_CAPSLOCK,		"CapsLock" },
		{ KVC_ENTER,		"Enter" },
		{ KVC_LCTRL,		"L-Ctrl" },
		{ KVC_RCTRL,		"R-Ctrl" },
		{ KVC_LSHIFT,		"L-Shift" },
		{ KVC_RSHIFT,		"R-Shift" },
		{ KVC_LALT,			"L-Alt" },
		{ KVC_RALT,			"R-Alt" },
		{ KVC_PRINT,		"PrintScreen" },
		{ KVC_SCROLLLOCK,	"ScrollLock" },
		{ KVC_PAUSE,		"Pause" },
		{ KVC_INSERT,		"Insert" },
		{ KVC_DELETE,		"Delete" },
		{ KVC_END,			"End" },
		{ KVC_HOME,			"Home" },
		{ KVC_PAGEUP,		"PageUp" },
		{ KVC_PAGEDOWN,		"PageDown" },
		
		{ KVC_UP,			"" },
		{ KVC_DOWN,			"" },
		{ KVC_LEFT,			"" },
		{ KVC_RIGHT,		"" },
		
		{ KVC_P0,			"0(eL[)" },
		{ KVC_P1,			"1(eL[)" },
		{ KVC_P2,			"2(eL[)" },
		{ KVC_P3,			"3(eL[)" },
		{ KVC_P4,			"4(eL[)" },
		{ KVC_P5,			"5(eL[)" },
		{ KVC_P6,			"6(eL[)" },
		{ KVC_P7,			"7(eL[)" },
		{ KVC_P8,			"8(eL[)" },
		{ KVC_P9,			"9(eL[)" },
		{ KVC_NUMLOCK,		"NumLock" },
		{ KVC_P_PLUS,		"+(eL[)" },
		{ KVC_P_MINUS,		"-(eL[)" },
		{ KVC_P_MULTIPLY,	"*(eL[)" },
		{ KVC_P_DIVIDE,		"/(eL[)" },
		{ KVC_P_PERIOD,		".(eL[)" },
		{ KVC_P_ENTER,		"Enter(eL[)" },
		
		// {L[{[ĥ
		{ KVC_YEN,			"\\" },
		{ KVC_RBRACKET,		"]" },
		{ KVC_UNDERSCORE,	"_" },
		{ KVC_MUHENKAN,		"ϊ" },
		{ KVC_HENKAN,		"ϊ" },
		{ KVC_HIRAGANA,		"Ђ炪" },
		
		// pL[{[ĥ
		{ KVE_BACKSLASH,	"BackSlash" },
		
		// ǉL[
		{ KVX_RMETA,		"L-Windows" },
		{ KVX_LMETA,		"R-Windows" },
		{ KVX_MENU,			"Menu" }
	};
	
	const char *str = NULL;
	for( int i=0; i<(int)(sizeof(kname)/sizeof(PCKeyName)); i++ ){
		if( kname[i].PCKey == sym ){
			str = kname[i].Name;
			break;
		}
	}
	return str;
}


////////////////////////////////////////////////////////////////
// tHgt@C쐬
//
// :	hfile		ptHgt@CpX
//			zfile		SptHgt@CpX
//			size		TCY(psNZ)
// Ԓl:	bool		true:쐬 false:쐬s
////////////////////////////////////////////////////////////////
bool OSD_CreateFont( char *hfile, char *zfile, int size )
{
	int ret = 0;
	int Wscr = size * 96 * 2;
	int Hscr = size * 96 * 2;
	
	
	// foCXReLXg擾
	HDC hBmpDC = CreateCompatibleDC( NULL );
	
	// tHg쐬
	HFONT NewFont = CreateFont( size * 2, size,
								FW_DONTCARE, FW_DONTCARE, FW_REGULAR,
								false, false, false,
								SHIFTJIS_CHARSET,
								OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
								DEFAULT_QUALITY,
								FF_MODERN | FIXED_PITCH, "" );
	HFONT OldFont = (HFONT)SelectObject( hBmpDC, NewFont );
	SetTextColor( hBmpDC, RGB(255,255,255) );
	SetBkColor(   hBmpDC, RGB(  0,  0,  0) );
	
	// Ɨprbg}bv쐬
	BYTE *ppixel;	// sNZf[^
	char bmbuf[sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*2];
	BITMAPINFO &bi        = *(BITMAPINFO *)&bmbuf;
	BITMAPINFOHEADER &bih = bi.bmiHeader;
	RGBQUAD *bc           = bi.bmiColors;
	ZeroMemory( &bih, sizeof(bmbuf) );
	
	bc[1].rgbBlue     = 255;
	bc[1].rgbGreen    = 255;
	bc[1].rgbRed      = 255;
	bc[1].rgbReserved = 0;
	
	bih.biSize     = sizeof(BITMAPINFOHEADER);
	bih.biWidth    = Wscr;
	bih.biHeight   = -Hscr;
	bih.biPlanes   = 1;
	bih.biBitCount = 8;
	HBITMAP hBmp   = CreateDIBSection( NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (void **)&ppixel, 0, 0 );
	ZeroMemory( ppixel, Wscr * Hscr );
	
	SelectObject( hBmpDC, hBmp );
	SelectObject( hBmpDC, GetStockObject( BLACK_BRUSH ) );
	
	// tHg`
	BYTE strk[2] = { 0x00, 0x00 };
	// p
	if( hfile ){
		Rectangle( hBmpDC, 0, 0, Wscr, Hscr );
		for( int y=0; y<2; y++ ){
			for( int x=32; x<128; x++ ){
				strk[0] = x + y * 128;
				TextOut( hBmpDC, x*size, y*size*2, (char *)strk, 1 );
			}
		}
		VSurface *FFont = new VSurface;
		FFont->InitSurface( Wscr, size*2*2, 8 );
		memcpy( (BYTE *)FFont->GetPixels(), ppixel, Wscr*size*2*2 );
		FFont->SetPalette( (COLOR24 *)bc, 2 );
		if( !SaveImg( hfile, FFont, NULL ) ) ret++;
		delete FFont;
	}
	
	// Sp
	if( zfile ){
		Rectangle( hBmpDC, 0, 0, Wscr, Hscr );
		for( int y=1; y<95; y++ ){
			for( int x=1; x<95; x++ ){
				strk[0] = y + 0x20;
				strk[1] = x + 0x20;
				Jis2Sjis( &strk[0], &strk[1] );
				TextOut( hBmpDC, x*size*2, y*size*2, (char *)strk, 2 );
			}
		}
		VSurface *FFont = new VSurface;
		FFont->InitSurface( Wscr, Hscr, 8 );
		memcpy( (BYTE *)FFont->GetPixels(), ppixel, Wscr*Hscr );
		FFont->SetPalette( (COLOR24 *)bc, 2 );
		if( !SaveImg( zfile, FFont, NULL ) ) ret++;
		delete FFont;
	}
	
	SelectObject( hBmpDC, OldFont );
	DeleteObject( NewFont );
	DeleteObject( hBmp );
	DeleteDC( hBmpDC );
	
	if( ret ) return false;
	else	  return true;
}
