#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include "typedef.h"
#include "vsurface.h"

#define	FSIZE		(6)	// ptHg̕

// F`
#define	FC_BLACK	(0)
#define	FC_DBLUE	(1)
#define	FC_DGREEN	(2)
#define	FC_DCYAN	(3)
#define	FC_DRED		(4)
#define	FC_DMAGENTA	(5)
#define	FC_DYELLOW	(6)
#define	FC_GRAY		(7)
#define	FC_BLUE		(9)
#define	FC_GREEN	(10)
#define	FC_CYAN		(11)
#define	FC_RED		(12)
#define	FC_MAGENTA	(13)
#define	FC_YELLOW	(14)
#define	FC_WHITE	(15)



////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class JFont {
protected:
	static VSurface *ZFont;		// SptHgf[^T[tFXւ̃|C^
	static VSurface *HFont;		// ptHgf[^T[tFXւ̃|C^
	
	static int zWidth, zHeight;	// Sp̕,
	static int hWidth, hHeight;	// p̕,
	
public:
	JFont();									// RXgN^
	~JFont();									// fXgN^
	
	static bool OpenFont( char *, char * );		// t@Ct@CJ
	static void CloseFont();					// tHgj
	
	static int FontWidth(){ return hWidth; }	// tHg̕擾(p)
	static int FontHeight(){ return hHeight; }	// tHg̍擾
	
	void PutCharh( VSurface *, int, int, BYTE, BYTE, BYTE );	// p`
	void PutCharz( VSurface *, int, int, WORD, BYTE, BYTE );	// Sp`

};


class ZCons : public JFont, public VSurface {
protected:
	VRect con;					// `͈
	int Xmax,Ymax;				// cő啶(p)
	int x,y;					// J[\ʒu
	BYTE fgc,bgc;				// `FƔwiF
	char Caption[129];			// LvV
	
	void DrawFrame();							// g`
	void ScrollUp();							// XN[Abv
	
public:
	ZCons();									// RXgN^
	virtual ~ZCons();							// fXgN^
	
	bool Init   ( int, int, const char *, int = FC_WHITE, int = FC_BLACK );	// (ŃTCYw)
	bool InitRes( int, int, const char *, int = FC_WHITE, int = FC_BLACK );	// (𑜓xŃTCYw)
	
	void Locate( int, int );					// J[\ʒuݒ
	void LocateR( int, int );					// J[\ʒuݒ(΍W)
	void SetColor( BYTE, BYTE );				// `Fݒ
	void SetColor( BYTE );
	void Cls();									// ʏ
	
	void PutCharH( BYTE );						// p1`
	void PutCharZ( WORD );						// Sp1`
	
	void Print( const char *, ... );			// t`(䕶Ή)
	void Printf( const char *, ... );			// t`(䕶Ή)
	void Printfr( const char *, ... );			// t`(El)
	
	int GetXline();								// ő啶擾
	int GetYline();								// cő啶擾
};


#endif	// CONSOLE_H_INCLUDED
