#ifndef D88_H_INCLUDED
#define D88_H_INCLUDED

#include "typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cD88 {
private:
	// D88 ZN^\
	struct D88SECTOR {
		BYTE c;				// ID  C (V_No Жʂ̏ꍇ=gbNNo)
		BYTE h;				// ID  H (wb_AhX Жʂ̏ꍇ=0)
		BYTE r;				// ID  R (gbÑZN^No)
		BYTE n;				// ID  N (ZN^TCY 0:128 1:256 2:512 3:1024)
		WORD sec_nr;		// ̃gbNɑ݂ZN^̐
		BYTE density;		// L^x     0x00:{x   0x40:Px
		BYTE deleted;		// DELETED MARK 0x00:m[} 0x10:DELETED
		BYTE status;		// Xe[^X
		BYTE reserve[5];	// U[u
		WORD size;			// ̃ZN^̃f[^TCY
		DWORD data;			// f[^ւ̃ItZbg
		WORD offset;		// ɓǍރf[^̃ZN^擪̃ItZbg
		WORD secno;			// ANZX̃ZN^No
		
		D88SECTOR() : c(0), h(0), r(0), n(0), sec_nr(0), density(0), deleted(0),
						status(0), size(0), data(0), offset(0), secno(0)
		{
			INITARRAY( reserve, 0 );
		}
	};
	
	// D88 \
	struct D88INFO {
		BYTE name[17];		// fBXN̖O(ASCII + '\0')
		BYTE reserve[9];	// U[u
		BYTE protect;		// CgveNg  0x00:Ȃ 0x10:
		BYTE type;			// fBXN̎    0x00:2D   0x10:2DD  0x20:2HD
		DWORD size;			// fBXÑTCY(wb_+SgbN)
		DWORD table[164];	// gbÑItZbge[u(Track 0-163)
		D88SECTOR secinfo;	// ZN^
		FILE *fp;			// FILE |C^
		int trkno;			// ANZX̃gbNNo
		
		D88INFO() : protect(0), type(0), size(0), fp(NULL), trkno(0)
		{
			INITARRAY( name, 0 );
			INITARRAY( reserve, 0 );
			INITARRAY( table, 0 );
		}
	};
	
	D88INFO d88;					// D88 
	char FileName[PATH_MAX];		// t@Cobt@
	
	bool Protected;					// veNgV[
	
	void ReadHeader88();			// D88 wb_Ǎ
	void ReadSector88();			// D88 ZN^Ǎ
	
public:
	cD88();							// RXgN^
	~cD88();						// fXgN^
	
	bool Init( char * );			// 
	
	BYTE Get8();					// 1byte Ǎ
	bool Put8( BYTE );				// 1byte 
	bool Seek( int, int = -1 );		// V[N
	bool SearchSector( BYTE, BYTE, BYTE, BYTE );	// ZN^T
	
	void GetID( BYTE *, BYTE *, BYTE *, BYTE * );	// ݂CHRN擾
	WORD GetSecSize();				// ݂̃ZN^TCY擾
	BYTE GetSecStatus();			// ݂̃Xe[^X擾
	
	char *GetFileName();			// t@C擾
	char *GetDiskImgName();			// DISKC[W擾
	bool IsProtect();				// veNgV[Ԏ擾
	
	BYTE Track();					// ݂̃gbNԍ擾
	BYTE Sector();					// ݂̃ZN^ԍ擾
	WORD SecNum();					// ݂̃gbNɑ݂ZN^擾

};

#endif	// D88_H_INCLUDED
