#ifndef PD8255_H_INCLUDED
#define PD8255_H_INCLUDED

#include "../typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cD8255 {
protected:
	BYTE PortA;						// |[gA
	BYTE PortB;						// |[gB
	BYTE PortC;						// |[gC
	
	BYTE PortAbuf;					// |[gAobt@(|[gA̓͂ꎞIɃb`)
	
	int ModeA;						// O[vA[h
	int ModeB;						// O[vB[h
	
	bool PortAdir;					// |[gA         o͐ true:(ǂ) false:o()
	bool PortBdir;					// |[gB         o͐ true:(ǂ) false:o()
	bool PortC1dir;					// |[gC(bit0-3) o͐ true:(ǂ) false:o()
	bool PortC2dir;					// |[gC(bit4-7) o͐ true:(ǂ) false:o()
	
	bool HSINT0;					// INT0
	bool HSWINT0;					// WINT0
	bool HSRINT0;					// RINT0
	bool HSSTB0;					// STB0
	bool HSIBF0;					// IBF0
	bool HSDAK0;					// DAK0
	bool HSOBF0;					// OBF0
	
	bool RIE0;						// RIE0
	bool WIE0;						// WIE0
	
	// o͏֐
	virtual void JobWriteA( BYTE ){}
	virtual void JobWriteB( BYTE ){}
	virtual void JobWriteC1( BYTE ){}	// 
	virtual void JobWriteC2( BYTE ){}	// 
	virtual void JobWriteD( BYTE ){}	// rbgZbg/Zbĝ
	virtual void JobReadA(){}
	virtual void JobReadB(){}
	virtual void JobReadC(){}
	
	void SetMode( BYTE );			// [hݒ
	
public:
	cD8255();						// RXgN^
	virtual ~cD8255();				// fXgN^
	
	void Reset();					// Zbg
	
	// o͊֐
	void WriteA( BYTE );
	void WriteB( BYTE );
	void WriteC( BYTE );
	void WriteD( BYTE );			// Rg[|[go
	BYTE ReadA();
	BYTE ReadB();
	BYTE ReadC();
	
	// [h2nhVFCNp
	void WriteAE( BYTE );			// PartA Cg(ӑ)
	BYTE ReadAE();					// PartA [h(ӑ)
	bool GetIBF();					// IBF擾
	bool GetOBF();					// OBF擾
};


#endif	// PD8255_H_INCLUDED
