#ifndef GRAPH_H_INCLUDED
#define GRAPH_H_INCLUDED

#include "typedef.h"
#include "p6vm.h"
#include "vsurface.h"

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSP6 {
protected:
	VM6* vm;
	
	HWINDOW Wh;				// EBhEnh
	VSurface *SBuf;			// Tuobt@|C^
	VPalette *Pal;			// pbgւ̃|C^
	int Bpp;				// J[[h
	int SLBr;				// XLCPx
	
	bool SetScreenSurface();				// XN[T[tFX쐬
	bool UpdateSubBuf();					// Tuobt@XV
	bool RefreshSubBuf();					// Tuobt@tbV
	
public:
	DSP6( VM6 * );							// RXgN^
	~DSP6();								// fXgN^
	
	bool Init( int, int, VPalette * );		// 
	void SetIcon( int );					// ACRݒ
	
	bool ResizeScreen();					// XN[TCYύX
	
	void DrawScreen();						// ʍXV
	void SnapShot( char * );				// XibvVbg
	
	int ScreenX();							// LXN[擾
	int ScreenY();							// LXN[擾
	
	VSurface *GetSubBuffer();				// Tuobt@擾
	HWINDOW GetWindowHandle();				// EBhEnh擾
};


#endif	// GRAPH_H_INCLUDED
