#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED

#include "typedef.h"
#include "semaphore.h"


// Xg[̍ő吔
// PSG + TAPE + VOICE = 3
#define	MAXSTREAM	(3)

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// Oobt@IuWFNg
class cRing : public cCritical {
private:
	int *Buffer;			// obt@ւ̃|C^
	
	int Size;				// obt@TCY(f[^)
	int Wpt;				// ݃|C^
	int Rpt;				// Ǎ݃|C^
	int Num;				// ǃf[^
	
public:
	cRing();								// RXgN^
	virtual ~cRing();						// fXgN^
	
	bool InitBuffer( int );					// obt@
	
	virtual int Get();						// Ǎ
	virtual bool Put( int );				// 
	
	int ReadySize();						// ǃf[^擾
	int FreeSize();							// cobt@擾
	int GetSize();							// obt@TCY擾
};


// TEhfoCXIuWFNg
class SndDev : public cRing {
protected:
	int SampleRate;			// Tv[g
	int Volume;				// 
	int LPF_Mem;			// [pXtB^p[N
	int LPF_fc;				// [pXtB^JbgItg
	
	int LPF( int );							// [pXtB^
	
public:
	SndDev();								// RXgN^
	virtual ~SndDev();						// fXgN^
	
	virtual bool Init( int );				// 
	
	int Get();								// Ǎ
	
	void SetLPF( int );						// [pXtB^ JbgItgݒ
	virtual bool SetSampleRate( int, int );	// TvO[gݒ
	virtual void SetVolume( int );			// ʐݒ
	virtual int SoundUpdate( int );			// Xg[XV
};


// TEhIuWFNg
class SND6 : public cRing {
private:
	SndDev *RB[MAXSTREAM];	// Xg[|C^z
	int Volume;				// }X^[
	int SampleRate;			// TvO[g
	int BSize;				// obt@TCY({)
	CBF_SND CbFunc;			// R[obN֐ւ̃|C^
	void *CbData;			// R[obN֐ɓnf[^
	
public:
	SND6();									// RXgN^
	~SND6();								// fXgN^
	
	bool Init( void *, CBF_SND, int, int );	// 
	
	bool ConnectStream( SndDev * );			// Xg[ڑ
	
	void Play();							// Đ
	void Pause();							// ~
	
	bool SetSampleRate( int );				// TvO[gݒ
	int GetSampleRate();					// TvO[g擾
	void SetVolume( int );					// }X^[ʐݒ
	
	int PreUpdate( int, cRing * = NULL );	// TEhOXV֐
	void Update( BYTE *, int );				// TEhXV֐
};

#endif	// SOUND_H_INCLUDED
