#ifndef STATUS_H_INCLUDED
#define STATUS_H_INCLUDED

#include "typedef.h"
#include "console.h"
#include "p6vm.h"


//------------------------------------------------------
//  Xe[^Xo[NX
//------------------------------------------------------
class cWndStat : public ZCons {
private:
	VM6* vm;
	
	char TapeName[MAX_PATH];			// t@C
	bool TapeIsAutoStart;				// I[gX^[g?
	bool TapeIsOpen;					// I[v?
	int TapeSize;						// TCY
	int TapeCount;						// JE^
	
	int DrvNum;							// hCu
	char DiskName[2][MAX_PATH];			// t@C
	bool DiskIsSystem[2];				// VXefBXN?
	bool DiskIsProtect[2];				// veNg?
	bool DiskIsAccess[2];				// ANZX?
	
	int	KeyIndicator;					// &CAPS CWP[^
	
	int	ReplayStatus;					// vCXe[^X
	
public:
	cWndStat( VM6 * );					// RXgN^
	~cWndStat();						// fXgN^
	
	bool Init( int, int = -1 );			// 
	void Update();						// EBhEXV
	
	void TapeMount( char *, bool, int );		// TAPE }Eg
	void TapeUnmount();							// TAPE A}Eg
	
	void DiskMount( int, char *, bool, bool );	// DISK }Eg
	void DiskUnmount( int );					// DISK A}Eg
	
	void SetReplayStatus( int );				// vCXe[^XZbg
};

#endif	// STATUS_H_INCLUDED
