#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

#include "ini.h"
#include "keydef.h"
#include "vsurface.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class CFG6 {
protected:
	cIni *Ini;								// INIIuWFNg|C^
	
	// INIt@CɕۑȂo
	char IniPath[PATH_MAX];					// INIt@CpX
	char Caption[256];						// EBhELvV
	char DokoFile[PATH_MAX];				// ǂłSAVEt@C
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bool MonDisp;							// j^EBhE\ true:\ false:\
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	
	// INIt@Cɕۑ郁o
	char RomPath[PATH_MAX];					// ROMpX
	char ExtRomPath[PATH_MAX];				// gROMpX
	char ExtRomFile[PATH_MAX];				// gROMt@C
	char WavePath[PATH_MAX];				// WAVEpX
	char TapePath[PATH_MAX];				// TAPEpX
	char TapeFile[PATH_MAX];				// TAPEt@C
	char SaveFile[PATH_MAX];				// TAPE(SAVE)t@C
	char DiskPath[PATH_MAX];				// DISKpX
	char DiskFile1[PATH_MAX];				// DISK1t@C
	char DiskFile2[PATH_MAX];				// DISK2t@C
	char ImgPath[PATH_MAX];					// XN[Vbgi[pX
	char PrinterFile[PATH_MAX];				// v^t@C
	
	// 萔
	static const P6KeyName P6KeyNameDef[];	// P6L[R[h ̒`
	static const PCKeyName PCKeyNameDef[];	// zL[R[h ̒`
	static const VKeyConv KeyIni[];			// zL[R[h -> P6L[R[h`l
	static const COLOR24 STDColor[];		// WJ[f[^
	
	
	void InitIni( cIni *, bool );			// INIIuWFNglݒ
	const char *GetPCKeyName( PCKEYsym );	// zL[R[h疼̎擾
	const char *GetP6KeyName( P6KEYsym );	// P6L[R[h疼̎擾
	PCKEYsym GetPCKeyCode( char * );		// L[̂牼zL[R[h擾
	P6KEYsym GetP6KeyCode( char * );		// L[̂P6L[R[h擾

public:
	CFG6();								// RXgN^
	virtual ~CFG6();						// fXgN^
	
	bool Init();							// (INIt@CǍ)
	bool Write();							// INIt@C
	
	// oANZX֐
	// 
	int GetModel();							// @擾
	void SetModel( int );					//     ݒ
	char *GetCaption();						// EBhELvV擾
	char *GetDokoFile();					// ǂłSAVEt@C擾
	void SetDokoFile( const char * );		//                       ݒ
	int GetOverClock();						// I[o[NbN擾
	void SetOverClock( int );				//                   ݒ
	
	// ֌W
	char *GetRomPath();						// ROMpX擾
	void SetRomPath( const char * );		//        ݒ
	bool GetUseExtRam();					// gRAMg擾
	void SetUseExtRam( bool );				//              ݒ
	char *GetExtRomPath();					// gROMpX擾
	void SetExtRomPath( const char * );		//            ݒ
	char *GetExtRomFile();					// gROMt@C擾
	void SetExtRomFile( const char * );		//                  ݒ
	bool GetCheckCRC();						// CRC`FbN擾
	void SetCheckCRC( bool );				//            ݒ
	bool GetRomPatch();						// ROMpb`擾
	void SetRomPatch( bool );				//          ݒ
	
	// L[{[h֌W
	int GetKeyRepeat();						// L[s[g擾
	void SetKeyRepeat( int );				//             ݒ
	
	// TEh֌W
	int GetSampleRate();					// TvO[g擾
	void SetSampleRate( int );				//                   ݒ
	int GetSoundBuffer();					// TEhobt@{擾
	void SetSoundBuffer( int );				//                       ݒ
	int GetMasterVol();						// }X^[ʎ擾
	void SetMasterVol( int );				//             ݒ
	
	// PSG֌W
	int GetPsgVol();						// PSGʎ擾
	void SetPsgVol( int );					//        ݒ
	int GetPsgLPF();						// PSG LPFJbgItg擾
	void SetPsgLPF( int );					//                        ݒ
	
	// ֌W
	char *GetWavePath();					// WAVEpX擾
	void SetWavePath( const char * );		//         ݒ
	int GetVoiceVol();						// ʎ擾
	void SetVoiceVol( int );				//             ݒ
	
	// CMT֌W
	char *GetTapePath();					// TAPEpX擾
	void SetTapePath( const char * );		//         ݒ
	char *GetTapeFile();					// TAPEt@C擾
	void SetTapeFile( const char * );		//               ݒ
	int GetCmtVol();						// TAPEj^ʎ擾
	void SetCmtVol( int );					//               ݒ
	bool GetTurboTAPE();					// Turbo TAPE LtO擾
	void SetTurboTAPE( bool );				//                      ݒ
	bool GetBoostUp();						// BoostUp LtO擾
	void SetBoostUp( bool );				//                   ݒ
	int GetMaxBoost1();						// BoostUp ő{(N60[h)擾
	void SetMaxBoost1( int );				//                            ݒ
	int GetMaxBoost2();						// BoostUp ő{(N60m/N66[h)擾
	void SetMaxBoost2( int );				//                                 ݒ
	char *GetSaveFile();					// TAPE(SAVE)t@C擾
	void SetSaveFile( const char * );		//                     ݒ
	
	// DISK֌W
	char *GetDiskPath();					// DISKpX擾
	void SetDiskPath( const char * );		//         ݒ
	char *GetDiskFile( int );				// DISKt@C擾
	void SetDiskFile( int, const char * );	//               ݒ
	int GetFddNum();						// FDDڑ䐔擾
	void SetFddNum( int );					//            ݒ
	
	// ʊ֌W
	char *GetImgPath();						// XN[Vbgi[pX擾
	void SetImgPath( const char * );		//                           ݒ
	int GetScrBpp();						// J[[h擾
	void SetScrBpp( int );					//             ݒ
	int GetMode4Color();					// [h4J[[h擾
	void SetMode4Color( int );				//                    ݒ
	bool GetScanLine();						// XLC擾
	void SetScanLine( bool );				//               ݒ
	int GetScanLineBr();					// XLCPx擾
	void SetScanLineBr( int );				//                   ݒ
	bool GetDispNTSC();						// 4:3\擾
	void SetDispNTSC( bool );				//        ݒ
	bool GetFullScreen();					// tXN[擾
	void SetFullScreen( bool );				//               ݒ
	bool GetStatDisp();						// Xe[^Xo[\Ԏ擾
	void SetStatDisp( bool );				//                       ݒ
	int GetFrameSkip();						// t[XLbv擾
	void SetFrameSkip( int );				//                 ݒ
	
	// rfILv`֌W
	bool GetAviRle();						// RLEtO擾
	void SetAviRle( bool );					//          ݒ
	
	// v^֌W
	char *GetPrinterFile();					// v^t@C擾
	void SetPrinterFile( const char * );	//                   ݒ
	
	// mF֌W
	bool GetCkQuit();						// ImF擾
	void SetCkQuit( bool );					//           ݒ
	bool GetSaveQuit();						// IINIۑ擾
	void SetSaveQuit( bool );				//              ݒ
	
	// @\Eg@\֌W
	bool GetUseSoldier();					// m̃J[gbWgtO擾
	void SetUseSoldier( bool );				//                             ݒ
	
	// pbg֌W
	COLOR24 *GetColor( int, COLOR24 * );	// J[f[^擾
	void SetColor( int, const COLOR24 * );	//             ݒ
	
	// L[`֌W
	P6KEYsym GetVKey( PCKEYsym );			// L[`擾
	void SetVKey( PCKEYsym, P6KEYsym );		//         ݒ
	int GetVKeyDef( VKeyConv ** );			// L[`z擾
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bool GetMonDisp();						// j^EBhE\Ԏ擾
	void SetMonDisp( bool );				// j^EBhE\Ԑݒ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// CONFIG_H_INCLUDED
