#ifndef AY8910_H_INCLUDED
#define AY8910_H_INCLUDED

#include "../typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cAY8910 {
protected:
	int RegisterLatch;
	BYTE Regs[16];
	int LastEnable;
	int UpdateStep;
	int PeriodA, PeriodB, PeriodC, PeriodN, PeriodE;
	int CountA, CountB, CountC, CountN, CountE;
	int VolA, VolB, VolC, VolE;
	BYTE EnvelopeA, EnvelopeB, EnvelopeC;
	BYTE OutputA, OutputB, OutputC, OutputN;
	int8_t CountEnv;
	BYTE Hold,Alternate,Attack,Holding;
	int RNG;
	int VolTable[32];
	
	void _AYWriteReg( BYTE, BYTE );		// WX^݃Tu
	void AYWriteReg( BYTE, BYTE );		// WX^
	BYTE AYReadReg( BYTE );				// WX^Ǎ
	
	void SetClock( int, int );			// PSGNbNݒ
	void SetVolumeTable( int );			// ʐݒ({[e[uݒ)
	
	// |[gANZX֐
	virtual BYTE PortAread();
	virtual BYTE PortBread();
	virtual void PortAwrite( BYTE );
	virtual void PortBwrite( BYTE );
	
	virtual void PreWriteReg() = 0;		// WX^ύXÕXg[XV
	
public:
	cAY8910();							// RXgN^
	virtual ~cAY8910();					// fXgN^
	
	void Reset();						// Zbg
	
	int Update1Sample();				// Xg[1SampleXV
};


#endif	// PSG_H_INCLUDED
