#ifndef IO_H_INCLUDED
#define IO_H_INCLUDED

#include "typedef.h"
#include "device.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class IO6 {
private:
	// IuWFNg|C^
	IOBus *io;								// I/OoX
	DeviceList *dl;							// foCXXg
	
	int Iwait[BANKSIZE];					// IN EFCge[u
	int Owait[BANKSIZE];					// OUTEFCge[u
	
public:
	IO6();									// RXgN^
	~IO6();									// fXgN^
	
	bool Init( int );						// 
	
	bool Connect( IDevice*, const IOBus::Connector* );	// foCXڑ
	bool Disconnect( IDevice* );						// foCXؒf
	
	BYTE In( int, int * = NULL );			// IN֐
	void Out( int, BYTE, int * = NULL );	// OUT֐
	
	void SetInWait( int, int );				// IN EFCgݒ
	void SetOutWait( int, int );			// OUTEFCgݒ
	int GetInWait( int );					// IN EFCg擾
	int GetOutWait( int );					// OUTEFCg擾
};


#endif		// IO_H_INCLUDED
