/*
	Skelton for Z-80 PC Emulator

	Author : Takeda.Toshiya
	Date   : 2004.04.26 -

	[ Device Base Class ]
*/
//  x[Xɂ݂낪׍H(ȗ)̂ł

#ifndef P6DEVICE_H_INCLUDED
#define P6DEVICE_H_INCLUDED

#include "typedef.h"
#include "p6vm.h"

class P6DEVICE {
public:
	typedef DWORD P6ID;
	
protected:
	VM6* vm;
	P6ID p6id;		// foCXID
	
public:
	P6DEVICE( VM6* parent_vm, const P6ID& id ) : vm( parent_vm ), p6id( id ){}
	virtual ~P6DEVICE(){}
	
	const P6ID& GetID() const { return p6id; }
	virtual void EventCallback( int, int ){}	// CxgR[obN֐
};



#endif		// P6DEVICE_H_INCLUDED
