#include "config.h"
#include "pio.h"
#include "cpus.h"
#include "intr.h"
#include "memory.h"
#include "vdg.h"


/*
BASIC ROM[`
								// 8049AɃf[^󂯎
Z0323:	LD	A,0CH		;E78	// WIE(6)Lɂ ܂菑ݗv݋֎~ INT=RINTƂ邽?
		OUT	(093H),A	;E7A
								// Ԃ񂱂̕ӂ̃^C~O8049f[^o͂STB(4)=LɂB
								// PortA̓b`,obt@̂IBF(5)=HƂȂB
								// ɂ8049̓f[^o͂~,STB(4)=HɂB
								// STB(4)̗オINT(3)=HƂȂB
								//  IBF(5)=H -> INT(3)=H ̏ɑ҂̂?
Z0319:	IN	A,(092H)	;E7C
		AND	08H			;E7E	// INT(3)HɂȂ܂ő҂
		JR	Z,0E7CH		;E80	// ܂8049̃f[^PortAɃb`܂ő҂
		IN	A,(092H)	;E82
		AND	020H		;E84	// IBF(5)HɂȂ܂ő҂ INT=HHɂȂĂ
		JR	Z,0E7CH		;E86	// ܂PortA̓̓obt@܂ő҂
		LD	A,0DH		;E88	// WIE(6)Hɂ ܂菑ݗv݋
		OUT	(093H),A	;E8A
		IN	A,(090H)	;E8C	// PortAf[^󂯎
		RET				;E8E
		
								// Ãf[^8049֑
Z0044:	PUSH	AF		;E8F
		LD	A,08H		;E90	// RIE(4)Lɂ ܂Ǎݗv݋֎~ INT=WINTƂ邽?
		OUT	(093H),A	;E92
Z0320:	IN	A,(092H)	;E94
		AND	08H			;E96	// INT(3)HɂȂ܂ő҂
		JR	Z,0E94H		;E98	// ܂8049f[^󂯎ăobt@ɂȂ܂ő҂ O񑗂f[^?
		IN	A,(092H)	;E9A
		AND	080H		;E9C	// OBF(7)HɂȂ܂ő҂ INT=HHɂȂĂ
		JR	Z,0E94H		;E9E	// ܂8049f[^󂯎DAK=HɂȂ܂ő҂ O񑗂f[^?
		LD	A,09H		;EA0	// RIE(4)Hɂ ܂Ǎݗv݋
		OUT	(093H),A	;EA2
		POP	AF			;EA4
		OUT	(090H),A	;EA5	// PortAɃf[^𑗂
		RET				;EA7


y8255 [h2̋z
bit3 INT(o)	[͂̏ꍇ]̏o͂8049̃f[^PortA()Ƀb`ꂽƂHƂȂ
				CPUɑ΂f[^Ǎݗv荞ݐMƂēB
				[o͂̏ꍇ]̏o͂8049f[^󂯎HƂȂ,CPUɑ΂
				̃f[^̏ݗv荞ݐMƂēB

bit4 STB()	̓͂Lɂ8049PortAɑĂMPortAb`
				[]IBFLɂȂOSTBLɂȂƃ|[gb`f[^ωĂ܂B
				@@@STBIBFLɂȂ܂łHɕۂȂ΂ȂȂB
				[⑫]8049~WRɌqĂ炵B܂8049PortAɏo͂瑦b`B

bit5 IBF(o)	̏o͂H̎PortA̓̓obt@Ă邱ƂӖ,8049ɑ΂ăf[^̓]̋֎~m点B
				̐MSTB̗HƂȂSTB=1̎̃f[^ǍݏI(~RDオ)LɂȂB
				[hݒ蒼̏lLłB

bit6 DAK()	̓͂8049PortA(o)̃f[^󂯎ƂƂm点MłB
				f[^󂯎L̐Mo悤8049݌vB
				[⑫]8049~RDɌqĂ炵B܂8049PortA͂瑦DAK=LɂȂB

bit7 OBF(o)	̐MCPŨf[^PortA(o)Ƀb`ꂽLƂȂ,8049ɑ΂Ẵf[^󂯎vƂēB
				OBFDAK=1̂Ƃ̃f[^ݏI(~WRオ)LɂȂ8049f[^󂯎DAK̗HɂȂB
				[hݒ蒼̏lHłB
				[]OBFHɂȂOɃf[^݂̏sPortA(o)ωĂ܂̂,OBFL̊Ԃ͏݂͔B
				[⑫]8049INTɌqĂ炵B܂8049݂͊Ńf[^󂯎B


bit4 RIE		CPUɑ΂f[^Ǎݗv荞݂̋tO,̃rbgrbg얽߂1ɂ邱ƂɂĊ荞݋,
				0ɂ邱ƂɂĊ荞݋֎~ɂB
				RIEĂrbgɊ蓖ĂĂSTB̋@\ɂ͉e^ȂB

bit6 WIE		CPUɑ΂f[^ݗv荞݂̋tO,̃rbgrbg얽߂1ɂ邱ƂɂĊ荞݋,
				0ɂ邱ƂɂĊ荞݋֎~ɂB
				WIEĂrbgɊ蓖ĂĂDAK̋@\ɂ͉e^ȂB
*/


// nhVFCNprbg
//#define	HS_INT	(0x08)	/* bit3 */
//#define	HS_STB	(0x10)	/* bit4 */
//#define	HS_IBF	(0x20)	/* bit5 */
//#define	HS_DAK	(0x40)	/* bit6 */
//#define	HS_OBF	(0x80)	/* bit7 */

//#define	HS_RIE	(0x10)	/* bit4 */
//#define	HS_WIE	(0x40)	/* bit6 */

////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cPRT::cPRT() : fp(NULL), pdata(0), strb(false)
{
	INITARRAY( FilePath, '\0' );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cPRT::~cPRT()
{
	if( fp ) fclose( fp );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cPRT::Init( char *filename )
{
	if( filename && *filename ){
		// t@CpXۑ
		strncpy( FilePath, filename, PATH_MAX );
	}
}


////////////////////////////////////////////////////////////////
// f[^t
//
// :	data	f[^f[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void cPRT::SetData( BYTE data )
{
	pdata = ~data;
}


////////////////////////////////////////////////////////////////
// Xg[ut
//
// :	st		Xg[uM true:L false:
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void cPRT::Strobe( bool st )
{
	if( !strb && st ){
		if( fp || (fp = FOPENEN( FilePath, "ab" )) ){
			fputc( pdata, fp );
		}
	}else{
		if( fp && strb && !st ){
			fclose( fp );
			fp = NULL;
		}
		strb = st;
	}
}




////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
PIO6::PIO6( VM6 *vm, const ID& id ) : P6DEVICE(vm,id), Device(id){}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
PIO6::~PIO6(){}


////////////////////////////////////////////////////////////////
// PartA Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void PIO6::JobWriteA( BYTE data )
{
	// [h2 DAK=H,OBF=L(܂WR0) Ȃ8049ɑ΂Ċݗv
	if( ModeA == 2 && HSDAK0 && !HSOBF0 )
		vm->cpus->ExtIntr();
}


////////////////////////////////////////////////////////////////
// PartB Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void PIO6::JobWriteB( BYTE data )
{
	// v^Ƀf[^o
	cPRT::SetData( data );
}


////////////////////////////////////////////////////////////////
// PartC Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void PIO6::JobWriteC1( BYTE data )
{
	// v^Xg[u
	cPRT::Strobe( data&1 ? false : true );
	
	// CRT\ؑ
	vm->vdg->SetCrtDisp( data&2 ? true : false );
	
	// CG ROM BANK ؑ
	vm->mem->SetCGBank( data&4 ? false : true );
}


////////////////////////////////////////////////////////////////
// PartD Cg(Rg[|[g)
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void PIO6::JobWriteD( BYTE data )
{
	// bit̑Ή
	switch( (data>>1)&0x07 ){
	case 0: // v^Xg[u
		cPRT::Strobe( data&1 ? false : true );
		break;
		
	case 1: // CRT\ؑ
		vm->vdg->SetCrtDisp( data&1 ? true : false );
		break;
		
	case 2: // CG ROM BANK ؑ
		vm->mem->SetCGBank( data&1 ? false : true );
		break;
	}
}


////////////////////////////////////////////////////////////////
// I/OANZX֐
////////////////////////////////////////////////////////////////
inline void PIO6::Out90H( int, BYTE data ){ WriteA( data ); }
inline void PIO6::Out91H( int, BYTE data ){ WriteB( data ); }
inline void PIO6::Out92H( int, BYTE data ){ WriteC( data ); }
inline void PIO6::Out93H( int, BYTE data ){ WriteD( data ); }
inline BYTE PIO6::In90H( int ){ return ReadA(); }
inline BYTE PIO6::In92H( int ){ return ReadC(); }
inline BYTE PIO6::In93H( int ){ return 0xff; }

inline void PIO6::OutPBH( int, BYTE data ){ WriteAE( data ); }
inline BYTE PIO6::InPBH( int ){ return ReadAE(); }
inline BYTE PIO6::InIBF( int ){ return GetIBF() ? 1 : 0; }
inline BYTE PIO6::InOBF( int ){ return GetOBF() ? 1 : 0; }


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool PIO6::DokoSave( cIni *Ini )
{
	if( !Ini ) return false;
	
	Ini->PutEntry( "8255", NULL, "PortA",		"0x%02X",	PortA );
	Ini->PutEntry( "8255", NULL, "PortB",		"0x%02X",	PortB );
	Ini->PutEntry( "8255", NULL, "PortC",		"0x%02X",	PortC );
	Ini->PutEntry( "8255", NULL, "PortAbuf",	"0x%02X",	PortAbuf );
	Ini->PutEntry( "8255", NULL, "ModeA",		"%d",		ModeA );
	Ini->PutEntry( "8255", NULL, "ModeB",		"%d",		ModeB );
	Ini->PutEntry( "8255", NULL, "PortAdir",	"%s",		PortAdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortBdir",	"%s",		PortBdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC1dir",	"%s",		PortC1dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC2dir",	"%s",		PortC2dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSINT0",		"%s",		HSINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSWINT0",		"%s",		HSWINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSRINT0",		"%s",		HSRINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSSTB0",		"%s",		HSSTB0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSIBF0",		"%s",		HSIBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSDAK0",		"%s",		HSDAK0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSOBF0",		"%s",		HSOBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "RIE0",		"%s",		RIE0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "WIE0",		"%s",		WIE0 ? "Yes" : "No" );
	
	return true;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool PIO6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return false;
	
	Ini->GetInt(   "8255", "PortA",		&st,		PortA );	PortA = st;
	Ini->GetInt(   "8255", "PortB",		&st,		PortB );	PortB = st;
	Ini->GetInt(   "8255", "PortC",		&st,		PortC );	PortC = st;
	Ini->GetInt(   "8255", "PortAbuf",	&st,		PortAbuf );	PortAbuf = st;
	Ini->GetInt(   "8255", "ModeA",		&ModeA,		ModeA );
	Ini->GetInt(   "8255", "ModeB",		&ModeB,		ModeB );
	Ini->GetTruth( "8255", "PortAdir",	&PortAdir,	PortAdir );
	Ini->GetTruth( "8255", "PortBdir",	&PortBdir,	PortBdir );
	Ini->GetTruth( "8255", "PortC1dir",	&PortC1dir,	PortC1dir );
	Ini->GetTruth( "8255", "PortC2dir",	&PortC2dir,	PortC2dir );
	Ini->GetTruth( "8255", "HSINT0",	&HSINT0,	HSINT0 );
	Ini->GetTruth( "8255", "HSWINT0",	&HSWINT0,	HSWINT0 );
	Ini->GetTruth( "8255", "HSRINT0",	&HSRINT0,	HSRINT0 );
	Ini->GetTruth( "8255", "HSSTB0",	&HSSTB0,	HSSTB0 );
	Ini->GetTruth( "8255", "HSIBF0",	&HSIBF0,	HSIBF0 );
	Ini->GetTruth( "8255", "HSDAK0",	&HSDAK0,	HSDAK0 );
	Ini->GetTruth( "8255", "HSOBF0",	&HSOBF0,	HSOBF0 );
	Ini->GetTruth( "8255", "RIE0",		&RIE0,	RIE0 );
	Ini->GetTruth( "8255", "WIE0",		&WIE0,	WIE0 );
	
	return true;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor PIO6::descriptor = {
	PIO6::indef, PIO6::outdef
};

const Device::OutFuncPtr PIO6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out90H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out91H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out93H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::OutPBH )
};

const Device::InFuncPtr PIO6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &PIO6::In90H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In92H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In93H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InPBH ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InIBF ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InOBF )
};
