#ifndef PIO_H_INCLUDED
#define PIO_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "p6device.h"
#include "device/pd8255.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cPRT {
private:
	char FilePath[PATH_MAX];		// PRINTERt@CtpX
	
	FILE *fp;						// FILE |C^
	BYTE pdata;						// p|[g󂯎f[^
	
	bool strb;						// Xg[u
	
public:
	cPRT();							// RXgN^
	~cPRT();						// fXgN^
	
	void Init( char * );			// 
	void SetData( BYTE );			// f[^t
	void Strobe( bool );			// Xg[ut
};




class PIO6 : public P6DEVICE, public Device, public cD8255, public cPRT, public IDoko {
private:
	// o͏֐
	void JobWriteA( BYTE );
	void JobWriteB( BYTE );
	void JobWriteC1( BYTE );
	void JobWriteD( BYTE );
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void Out90H( int, BYTE );
	void Out91H( int, BYTE );
	void Out92H( int, BYTE );
	void Out93H( int, BYTE );
	BYTE In90H( int );
	BYTE In92H( int );
	BYTE In93H( int );
	
	void OutPBH( int, BYTE );
	BYTE InPBH( int );
	BYTE InIBF( int );
	BYTE InOBF( int );
	
public:
	PIO6( VM6 *, const ID& );		// RXgN^
	~PIO6();						// fXgN^
	
	// foCXID
	enum IDOut{ out90H=0, out91H, out92H, out93H, outPBH                 };
	enum IDIn {  in90H=0,          in92H,  in93H,  inPBH,  inIBF,  inOBF };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// PIO_H_INCLUDED
