#ifndef PSG_H_INCLUDED
#define PSG_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "sound.h"
#include "p6device.h"
#include "device/ay8910.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class PSG6 : public P6DEVICE, public Device, public cAY8910, public SndDev, public IDoko {
private:
	BYTE JoyNo;							// ǎWCXeBbN̔ԍ(0-1)
	int Clock;							// NbN
	
	// |[gANZX֐
	BYTE PortAread();
	void PortBwrite( BYTE );
	
	int GetUpdateSamples();				// XVTv擾
	void PreWriteReg();					// WX^ύXÕXg[XV
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutA0H( int, BYTE );			// PSGWX^AhXb`
	void OutA1H( int, BYTE );			// PSGCgf[^
	void OutA3H( int, BYTE );			// PSGCANeBu
	BYTE InA2H( int );					// PSG[hf[^
	
public:
	PSG6( VM6 *, const ID& );			// RXgN^
	~PSG6();							// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int, int );				// 
	
	bool SetSampleRate( int, int );		// TvO[gݒ
	
	int SoundUpdate( int );				// Xg[XV
	
	// foCXID
	enum IDOut{ outA0H=0, outA1H, outA3H };
	enum IDIn {  inA2H=0 };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


#endif	// AY8910_H_INCLUDED
