#ifndef REPLAY_H_INCLUDED
#define REPLAY_H_INCLUDED

#include "typedef.h"
#include "ini.h"

#define	REP_IDLE	(0)
#define	REP_RECORD	(1)
#define	REP_REPLAY	(2)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class REPLAY {
protected:
	cIni *Ini;
	
	int RepST;					// Xe[^X
	
	BYTE *Matrix;				// L[}gNXobt@|C^
	int MSize;					// L[}gNXTCY
	
	DWORD RepFrm;				// t[No.JE^
	DWORD EndFrm;				// vCIt[
	
public:
	REPLAY();								// RXgN^
	~REPLAY();								// fXgN^
	
	bool Init( int );						// 
	
	int GetStatus();						// Xe[^X擾
	
	bool StartRecord( char * );				// vCL^Jn
	void StopRecord();						// vCL^~
	bool ReplayWriteFrame( BYTE *, bool );	// vC1t[o
	
	bool StartReplay( char * );				// vCĐJn
	void StopReplay();						// vCĐ~
	bool ReplayReadFrame( BYTE * );			// vC1t[Ǎ
	
};


#endif	// REPLAY_H_INCLUDED
